'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.kaHighlightValueConverter = exports.KaInputControls = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _dec17, _dec18, _dec19, _dec20, _dec21, _dec22, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _descriptor17, _descriptor18, _descriptor19;

var _aureliaFramework = require('aurelia-framework');

var _aureliaRouter = require('aurelia-router');

var _aureliaValidation = require('aurelia-validation');

var _aureliaHttpClient = require('aurelia-http-client');

var _kaDialog = require('../ka-dialog/ka-dialog');

var _kaCkeditor = require('ka-ckeditor');

var _kaCkeditor2 = _interopRequireDefault(_kaCkeditor);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var KaInputControls = exports.KaInputControls = (_dec = (0, _aureliaFramework.customElement)('ka-input-controls'), _dec2 = (0, _aureliaFramework.containerless)(), _dec3 = (0, _aureliaFramework.inject)(Element, _aureliaRouter.Router, _aureliaFramework.NewInstance.of(_aureliaValidation.ValidationController), _aureliaFramework.BindingEngine, _kaDialog.KaDialog), _dec4 = (0, _aureliaFramework.bindable)({ defaultBindingMode: _aureliaFramework.bindingMode.twoWay }), _dec5 = (0, _aureliaFramework.bindable)({ defaultBindingMode: _aureliaFramework.bindingMode.twoWay }), _dec6 = (0, _aureliaFramework.bindable)({ defaultBindingMode: _aureliaFramework.bindingMode.twoWay }), _dec7 = (0, _aureliaFramework.bindable)(), _dec8 = (0, _aureliaFramework.bindable)(), _dec9 = (0, _aureliaFramework.bindable)(), _dec10 = (0, _aureliaFramework.bindable)(), _dec11 = (0, _aureliaFramework.bindable)(), _dec12 = (0, _aureliaFramework.bindable)(), _dec13 = (0, _aureliaFramework.bindable)(), _dec14 = (0, _aureliaFramework.bindable)(), _dec15 = (0, _aureliaFramework.bindable)(), _dec16 = (0, _aureliaFramework.bindable)(), _dec17 = (0, _aureliaFramework.bindable)(), _dec18 = (0, _aureliaFramework.bindable)(), _dec19 = (0, _aureliaFramework.bindable)(), _dec20 = (0, _aureliaFramework.bindable)(), _dec21 = (0, _aureliaFramework.bindable)(), _dec22 = (0, _aureliaFramework.bindable)(), _dec(_class = _dec2(_class = _dec3(_class = (_class2 = function () {
  function KaInputControls(element, router, validator, bindingEngine, dialog) {
    _classCallCheck(this, KaInputControls);

    _initDefineProp(this, 'value', _descriptor, this);

    _initDefineProp(this, 'displayValue', _descriptor2, this);

    _initDefineProp(this, 'objectValue', _descriptor3, this);

    _initDefineProp(this, 'config', _descriptor4, this);

    _initDefineProp(this, 'record', _descriptor5, this);

    _initDefineProp(this, 'name', _descriptor6, this);

    _initDefineProp(this, 'label', _descriptor7, this);

    _initDefineProp(this, 'default', _descriptor8, this);

    _initDefineProp(this, 'required', _descriptor9, this);

    _initDefineProp(this, 'readonly', _descriptor10, this);

    _initDefineProp(this, 'control', _descriptor11, this);

    _initDefineProp(this, 'client', _descriptor12, this);

    _initDefineProp(this, 'description', _descriptor13, this);

    _initDefineProp(this, 'validation', _descriptor14, this);

    _initDefineProp(this, 'queryOperator', _descriptor15, this);

    _initDefineProp(this, 'change', _descriptor16, this);

    _initDefineProp(this, 'ready', _descriptor17, this);

    _initDefineProp(this, 'dialogClosed', _descriptor18, this);

    _initDefineProp(this, 'comboListItems', _descriptor19, this);

    this.element = element;
    this.router = router;
    this.bindingEngine = bindingEngine;
    this.dialog = dialog;
    this.validator = validator;
    this.validator.validateTrigger = _aureliaValidation.validateTrigger.manual;
    this._client = new _aureliaHttpClient.HttpClient();
    this._client.configure(function (x) {
      x.withInterceptor({
        response: function response(msg) {
          if (msg.responseType === 'json' && typeof msg.response === 'string') {
            msg.response = JSON.parse(msg.response);
          }
          return msg;
        }
      });
    });

    _aureliaValidation.ValidationRules.ensure('value').required().when(function (self) {
      return self.required;
    }).withMessage('Campo obbligatorio').equals(true).when(function (self) {
      return self.control === 'check' && self.required;
    }).withMessage('Spunta obbligatoria').satisfies(function (value, self) {
      return value >= self.min && value <= self.max;
    }).when(function (self) {
      return self.control === 'number' && self.min && self.max;
    }).withMessage('Il valore deve essere compreso tra ${min} e ${max}').satisfies(function (value, self) {
      return value >= self.min;
    }).when(function (self) {
      return self.control === 'number' && self.min && !self.max;
    }).withMessage('Il valore deve essere uguale o maggiore di ${min}').satisfies(function (value, self) {
      return value <= self.max;
    }).when(function (self) {
      return self.control === 'number' && !self.min && self.max;
    }).withMessage('Il valore deve essere minore o uguale a ${max}').satisfies(function (value, self) {
      return value.length >= self.min && value.length <= self.max;
    }).when(function (self) {
      return self.value && ['text', 'textarea', 'password'].includes(self.control) && self.min && self.max;
    }).withMessage('Il numero di caratteri deve essere compreso tra ${min} e ${max}').satisfies(function (value, self) {
      return value.length >= self.min;
    }).when(function (self) {
      return self.value && ['text', 'textarea', 'password'].includes(self.control) && self.min && !self.max;
    }).withMessage('Il valore deve essere di almeno ${min} caratteri').satisfies(function (value, self) {
      return value.length <= self.max;
    }).when(function (self) {
      return self.value && ['text', 'textarea', 'password'].includes(self.control) && !self.min && self.max;
    }).withMessage('Il valore non deve superare i ${max} caratteri').ensure('displayValue').required().when(function (self) {
      return self.required;
    }).withMessage('Campo obbligatorio').satisfies(function (value, self) {
      return value === null || value === '' || /^\d{2}\/\d{2}\/\d{4}$/g.test(value) && (0, _moment2.default)(value, 'DD-MM-YYYY').isValid();
    }).when(function (self) {
      return self.control === 'date' || self.control === 'age';
    }).withMessage('Formato data non valido').on(this);
  }

  KaInputControls.prototype.bind = function bind(bindingContext, overrideContext) {
    this.parentContext = bindingContext;
  };

  KaInputControls.prototype.attached = function attached() {
    this.init();
  };

  KaInputControls.prototype.init = function init() {
    var _this = this;

    if (!this.initialized) {
      if (!this.config || !this.element || !this.element.parentElement) return;
      this.element = this.element.parentElement;
    }

    this.initialized = true;

    var config_overrides = {
      label: this.label !== null ? this.label : this.config && this.config.label ? this.config.label : null,
      default: this.default !== null ? this.default : this.config && this.config.default ? this.config.default : null,
      required: this.required !== null ? this.required === 'true' || this.required === true : this.config && this.config.required ? this.config.required : null,
      readonly: this.readonly !== null ? this.readonly === 'true' || this.readonly === true : this.config && this.config.readonly ? this.config.readonly : null,
      control: this.control !== null ? this.control : this.config && this.config.control ? this.config.control : null
    };
    Object.assign(this, this.config, config_overrides);
    this.config = null;

    this.id = 'ka-input-' + (this.field || 'noname') + '-' + Math.random().toString(36).slice(-6);

    if (typeof this.datasource === 'string' && (this.datasource.indexOf('{') === 0 || this.datasource.indexOf('[') === 0)) {
      this.datasource = JSON.parse(this.datasource);
      if (this.datasource.table && this.datasource.table.indexOf('_') === 0) this.datasource.table = this.datasource.table.substring(1);
    }
    if (this.datasource && !this.datatext) this.datatext = 'text';
    if (this.datasource && !this.datavalue) this.datavalue = 'value';

    if (!this.value && this.default) this.value = this.default;
    if (this.value && _typeof(this.value) === 'object' && this.datasource && this.datavalue && this.value[this.datavalue]) this.value = String(this.value[this.datavalue]);
    if (this.value && _typeof(this.value) === 'object' && this.datatype === 'json') this.value = JSON.stringify(this.value);

    var input = void 0;
    switch (this.control) {
      case 'text':
        this.type = 'text';
        input = this.element.querySelector('input');
        if (input && this.min) input.setAttribute('minlength', this.min);
        if (input && this.max) input.setAttribute('maxlength', this.max);
        break;
      case 'textarea':
        this.type = 'textarea';
        input = this.element.querySelector('textarea');
        if (input && this.min) input.setAttribute('minlength', this.min);
        if (input && this.max) input.setAttribute('maxlength', this.max);
        break;
      case 'password':
        this.type = 'password';
        input = this.element.querySelector('input');
        if (input && this.min) input.setAttribute('minlength', this.min);
        if (input && this.max) input.setAttribute('maxlength', this.max);
        break;
      case 'number':
        this.type = 'number';
        input = this.element.querySelector('input');
        if (input && this.min) input.setAttribute('min', this.min);
        if (input && this.max) input.setAttribute('max', this.max);
        break;
      case 'check':
        this.type = !this.datamultiple ? 'checkbox' : 'checklist';
        if (this.datamultiple && this.datapreload) this.checklistInit();
        if (this.datamultiple && !this.datapreload) this.comboListUpdate();
        break;
      case 'date':
      case 'age':
        this.type = 'text';
        this.placeholder = this.placeholder || 'gg/mm/aaaa';
        this.dateInit();
        break;
      case 'time':
        this.type = 'time';
        this.placeholder = this.placeholder || 'HH:mm';
        break;
      case 'combo':
        this.type = 'combo';
        this.comboInit();
        break;
      case 'editor':
        this.type = 'editor';
        this.editorInit();
        break;
      case 'file':
        this.type = 'file';
        break;
      default:
        this.type = 'text';
        break;
    }
    this.element.classList.add('type-' + this.type);

    if (this.element.hasAttribute('description')) this.description = this.element.getAttribute('description');else if (this.control === 'check' && !this.datamultiple && !this.description) {
      this.description = this.label;this.label = null;
    }
    if (this.element.hasAttribute('placeholder')) this.placeholder = this.element.getAttribute('placeholder');else this.placeholder = this.placeholder || '';

    if (this.readonly) this.element.classList.add('readonly');
    if (this.required) this.element.classList.add('required');

    this.buttons = {};
    if (!this.element.classList.contains('no-buttons')) {
      if (!this.element.classList.contains('no-clear') && this.control !== 'editor' && this.control !== 'check') this.buttons.clearEnabled = true;
      if (!this.element.classList.contains('no-add') && this.control === 'combo' && this.datasource && this.datasource.table && !this.datamultiple) this.buttons.addEnabled = !this.value;
      if (!this.element.classList.contains('no-open') && this.control === 'combo' && this.datasource && this.datasource.table && !this.datamultiple) this.buttons.openEnabled = !!this.value;
      if (this.control === 'password') this.buttons.showEnabled = true;
      if (this.control === 'file') this.buttons.downloadEnabled = true;
    }
    this.buttons.length = Object.keys(this.buttons).length;

    this.buttons.clear = function () {
      _this.value = null;
      if (_this.control === 'date' || _this.control === 'age') _this.dateDisplayValue();
      if (_this.control === 'combo') _this.comboDisplayValue();
      _this.validate();
    };
    this.buttons.open = function () {
      var childRoute = _this.router.routes.filter(function (x) {
        return x.name == (_this.datasource.table || _this.router.currentInstruction.config.name);
      })[0];
      if (!childRoute || !_this.value || isNaN(parseInt(_this.value, 10))) return;
      _this.dialog.open({
        title: childRoute.title,
        viewModel: childRoute.moduleId,
        viewModelParams: { id: _this.value }
      }, true).whenClosed(function (response) {
        if (_this.control == 'combo') {
          _this.comboItemsSource = null;
          _this.comboDisplayValue();
        }
        if (typeof _this.dialogClosed === 'function') _this.dialogClosed(response);
      });
    };
    this.buttons.add = function () {
      var childRoute = _this.router.routes.filter(function (x) {
        return x.name == (_this.datasource.table || _this.router.currentInstruction.config.name);
      })[0];
      if (!childRoute || _this.value) return;
      _this.dialog.open({
        title: childRoute.title,
        viewModel: childRoute.moduleId,
        viewModelParams: { id: 'new' }
      }, true).whenClosed(function (response) {
        if (response.output && response.output.id) {
          _this.value = response.output.id;
        }
        if (typeof _this.dialogClosed === 'function') _this.dialogClosed(response);
      });
    };
    this.buttons.show = function () {
      _this.type = 'text';
      _this.buttons.showEnabled = false;
      _this.buttons.hideEnabled = true;
    };
    this.buttons.hide = function () {
      _this.type = 'password';
      _this.buttons.showEnabled = true;
      _this.buttons.hideEnabled = false;
    };
    this.buttons.download = function () {
      if (!_this.value) return;
      var download = _this.element.hasAttribute('download') && _this.element.getAttribute('download') === 'false' ? 0 : 1;
      window.open(_this.client._baseUrl + 'storage/' + _this.record + '/' + _this.field + '?download=' + download + '&access_token=' + (localStorage.getItem('access_token') || sessionStorage.getItem('access_token')));
    };
    if (this.control === 'combo') {} else {
      this._ready = true;
      if (typeof this.ready === 'function') this.ready(this);
      this.format();
    }
  };

  KaInputControls.prototype.configChanged = function configChanged(value) {
    if (value) this.init();
  };

  KaInputControls.prototype.valueChanged = function valueChanged(value) {
    var _this2 = this;

    if (this.control === 'date' || this.control === 'age') {
      this.dateDisplayValue();
    }
    if (this.control === 'combo') {
      this.comboDisplayValue();
    }
    if (this.control === 'check' && this.datamultiple) {
      if (this.datapreload) this.checklistParseSelected();else this.comboListUpdate();
    }
    if (this.control === 'editor' && this.editor && this.editor.data) {
      if (this.editor.data.get() !== value) this.editor.data.set(value || '');
    }
    if (this.control === 'file') {
      this.fileDisplayValue();
    }
    if (this.value && _typeof(this.value) === 'object' && this.datatype === 'json') {
      this.value = JSON.stringify(this.value);
    }
    if (typeof this.change === 'function' && this._ready) {
      setTimeout(function () {
        _this2.change({ value: _this2.value });
      }, 100);
    }
  };

  KaInputControls.prototype.requiredChanged = function requiredChanged(value) {
    if (!this.initialized) return;
    if (value) this.element.classList.add('required');else this.element.classList.remove('required');
  };

  KaInputControls.prototype.readonlyChanged = function readonlyChanged(value) {
    if (!this.initialized) return;
    if (value) this.element.classList.add('readonly');else this.element.classList.remove('readonly');
    if (this.control === 'editor' && this.editor) this.editor.isReadOnly = value;
  };

  KaInputControls.prototype.focus = function focus() {
    if (this.readonly) return;
    this.element.classList.add('focus');
  };

  KaInputControls.prototype.blur = function blur() {
    if (this.readonly) return;
    this.element.classList.remove('focus');
    this.validate();
  };

  KaInputControls.prototype.keyup = function keyup($event) {
    if (this.control === 'date' || this.control === 'age') {
      if (!this.displayValue || $event.keyCode === 8 || $event.keyCode === 9 || $event.keyCode === 16 || $event.keyCode === 46) return;
      var value = this.displayValue.split('-');
      value = (value[2] ? value[2] + '/' : '') + (value[1] ? value[1] + '/' : '') + (value[0] ? value[0] : '');
      if (!/^([0123]|(?:0[1-9])|[12]\d|3[01])$|^(\d{2})\/$|^(\d{2})\/([01]|(?:0[1-9])|1[012])$|^(\d{2})\/(\d{2})\/$|^(\d{2})\/(\d{2})\/(\d{0,4})$/g.test(value)) value = value.slice(0, -1);
      if (/^\d{2}$|^\d{2}\/\d{2}$/g.test(value)) value += '/';
      this.displayValue = value;
    }
  };

  KaInputControls.prototype.format = function format() {
    if (typeof this.value === 'undefined') return;
    switch (this.control) {
      case 'text':
        this.value = this.value;
        break;
      case 'password':
        this.value = !this.value || this.value.length === 0 ? null : this.value;
        break;
      case 'number':
        this.value = this.value;
        break;
      case 'date':
      case 'age':
        this.value = !this.displayValue || this.displayValue === '' || this.displayValue === '0000-00-00' ? null : /^\d{2}\/\d{2}\/\d{4}$/g.test(this.displayValue) && (0, _moment2.default)(this.displayValue, 'DD/MM/YYYY').isValid() ? (0, _moment2.default)(this.displayValue, 'DD/MM/YYYY').format('YYYY-MM-DD') : this.displayValue;
        break;
      case 'combo':
        this.value = this.value;
        break;
      case 'file':
        this.value = this.value;
        break;
      default:
        this.value = this.value;
        break;
    }
  };

  KaInputControls.prototype.validate = function validate() {
    var _this3 = this;

    this.format();
    if (!this.validation) {
      return new Promise(function (resolve) {
        _this3.element.classList.remove('error');
        resolve({
          instruction: undefined,
          results: [],
          valid: true
        });
      });
    }
    return new Promise(function (resolve, reject) {
      _this3.validator.validate().then(function (result) {
        if (result.valid) {
          _this3.element.classList.remove('error');
          return resolve(result);
        }

        _this3.element.classList.add('error');
        return reject(result);
      });
    });
  };

  KaInputControls.prototype.dateInit = function dateInit() {
    if (this.value && !this.displayValue) this.dateDisplayValue();
  };

  KaInputControls.prototype.dateDisplayValue = function dateDisplayValue() {
    if (typeof this.value === 'undefined' || this.value === '' || this.value === '0000-00-00') return this.value = null;
    this.displayValue = !this.value || this.value === '' || this.value === '0000-00-00' ? null : /^\d{4}-\d{2}-\d{2}$/g.test(this.value) ? (0, _moment2.default)(this.value, 'YYYY-MM-DD').format('DD/MM/YYYY') : this.value;
  };

  KaInputControls.prototype.checkClick = function checkClick($event) {
    if (this.readonly) {
      $event.preventDefault();
      $event.stopPropagation();
    } else {
      this.value = !this.value;
      this.validate();
    }
  };

  KaInputControls.prototype.editorInit = function editorInit() {
    var _this4 = this;

    if (this._editor_initialized) return;
    var config = {
      toolbar: ['heading', '|', 'bold', 'italic', 'link', 'bulletedList', 'numberedList', '|', 'indent', 'outdent', '|', 'blockQuote', 'insertTable', 'mediaEmbed', 'undo', 'redo'],
      heading: {
        options: [{
          model: 'paragraph',
          view: 'p',
          title: 'Paragrafo',
          class: 'ck-heading_paragraph'
        }, {
          model: 'heading1',
          view: 'h2',
          title: 'Intestazione 1',
          class: 'ck-heading_heading1'
        }, {
          model: 'heading2',
          view: 'h3',
          title: 'Intestazione 2',
          class: 'ck-heading_heading2'
        }, {
          model: 'heading3',
          view: 'h4',
          title: 'Intestazione 3',
          class: 'ck-heading_heading3'
        }]
      }
    };
    _kaCkeditor2.default.create(this.element.querySelector('.ka-input-editor'), config).then(function (editor) {
      editor.data.set(_this4.value || '');
      editor.isReadOnly = _this4.readonly;
      editor.model.document.on('change:data', function () {
        _this4.value = editor.data.get();
      });
      _this4.editor = editor;
    }).catch(function (error) {
      konsole.error('There was a problem initializing ckeditor', error);
    }).finally(function () {
      _this4._editor_initialized = true;
    });
  };

  KaInputControls.prototype.fileInit = function fileInit() {};

  KaInputControls.prototype.fileDisplayValue = function fileDisplayValue() {
    if (typeof this.value === 'undefined' || this.value === '' || this.value && !this.value.length) return this.value = null;
    if (this.value === null) {
      var form = document.createElement('form');
      form.style.display = 'none';
      this.element.parentElement.insertBefore(form, this.element);
      form.append(this.element);
      form.reset();
      form.parentElement.insertBefore(this.element, form);
      form.remove();
    }
    this.displayValue = this.value && this.value.length && this.value[0] && this.value[0].name ? this.value[0].name : this.value;
  };

  KaInputControls.prototype.comboInit = function comboInit() {
    if (this.value && !this.displayValue) this.comboDisplayValue();
  };

  KaInputControls.prototype.comboOpen = function comboOpen() {
    var _this5 = this;

    if (this.readonly) return;
    if (this.comboOpened) return this.comboClose();

    if (!this.backdrop) {
      this.backdrop = document.createElement('div');
      this.backdrop.classList.add('ka-input-backdrop');
      this.backdrop.setAttribute('id', 'ka-input-backdrop-' + this.field);
      this.backdrop.addEventListener('click', function (event) {
        if (event.target == _this5.backdrop) _this5.comboClose();
      });
    }
    this.backdrop.style.display = 'block';
    document.body.insertBefore(this.backdrop, document.body.children[0]);

    this.comboOpened = true;
    this.comboItems = [];
    setTimeout(function () {
      var bounds = _this5.drawer.getBoundingClientRect();
      var max_h = _this5.backdrop.getBoundingClientRect().height;
      _this5.backdrop.appendChild(_this5.drawer);
      if (bounds.top + 280 > max_h) {
        _this5.drawer.style.top = 'auto';
        _this5.drawer.style.bottom = max_h - bounds.top - 30 + 60 + 'px';
      } else {
        _this5.drawer.style.top = bounds.top + 'px';
        _this5.drawer.style.bottom = 'auto';
      }
      _this5.drawer.style.left = bounds.left + 'px';
      _this5.drawer.style.width = bounds.width + 'px';
      _this5.comboReady = true;
      _this5.comboQuery();
    }, 200);
  };

  KaInputControls.prototype.comboClose = function comboClose() {
    this.drawer.style = {};
    this.combo.appendChild(this.drawer);

    this.backdrop.style.display = 'none';

    this.comboOpened = false;
    this.comboReady = false;
    this.comboQueryValue = null;
  };

  KaInputControls.prototype.comboQuery = function comboQuery(query) {
    var _this6 = this;

    this.comboGetItems(query).then(function (items) {
      _this6.comboItems = items;
      _this6.comboParseSelected();
    });
  };

  KaInputControls.prototype.comboGetItems = function comboGetItems(query, value) {
    var _this7 = this;

    return new Promise(function (resolve, reject) {
      var items = [];
      var client = !_this7.client || _this7.datasource.url ? _this7._client : _this7.client;
      var datasource = null;

      if (typeof _this7.datasource === 'string' && (_this7.datasource.indexOf('{') === 0 || _this7.datasource.indexOf('[') === 0)) datasource = JSON.parse(_this7.datasource);else if (typeof _this7.datasource === 'string' && _this7.parentContext.datasources && _this7.parentContext.datasources[_this7.datasource]) datasource = _this7.parentContext.datasources[_this7.datasource];else if (Array.isArray(_this7.datasource)) datasource = _this7.datasource;else datasource = _this7.datasource;

      if (_this7.datapreload && (!_this7.comboItemsSource || !query && !value) && (datasource.table || datasource.url)) {
        if (_this7.comboItemsSource) {
          items = _this7.comboItemsSource;
          if (query) _this7.comboGetItems(query).then(function (items) {
            resolve(items);
          });
          if (value) _this7.comboGetItems(null, value).then(function (items) {
            resolve(items);
          });else resolve(items);
        } else client.get(datasource.table || datasource.url, { distinct: true }).then(function (x) {
          items = _this7.comboItemsSource = _this7.parse_response(x);
          if (query) _this7.comboGetItems(query).then(function (items) {
            resolve(items);
          });
          if (value) _this7.comboGetItems(null, value).then(function (items) {
            resolve(items);
          });else resolve(items);
        }).catch(function (x) {});
      } else if (_this7.datapreload && (!_this7.comboItemsSource || !query && !value) && Array.isArray(datasource)) {
        items = _this7.comboItemsSource = datasource;
        if (!query && !value) resolve(items);
      }

      if (_this7.datapreload && _this7.comboItemsSource && query) {
        items = _this7.comboItemsSource.filter(function (x) {
          return x[_this7.datatext].toLowerCase().indexOf(query.toLowerCase()) >= 0;
        });
        resolve(items);
      } else if (_this7.datapreload && _this7.comboItemsSource && value) {
        items = _this7.comboItemsSource.filter(function (x) {
          return String(x[_this7.datavalue]) == String(value);
        });
        resolve(items);
      } else if (!_this7.datapreload && !query && !value && (datasource.table || datasource.url)) {
        resolve(items);
      } else if (!_this7.datapreload && query && (datasource.table || datasource.url)) {
        var endpoint = datasource.table || datasource.url;
        if (datasource.query && _typeof(datasource.query) === 'object' && datasource.query.search) {
          endpoint = _this7.addUrlParam(endpoint, datasource.query.search, query);
        } else if (datasource.query && typeof datasource.query === 'string') {
          endpoint = _this7.addUrlParam(endpoint, datasource.query, query);
        } else {
          var params = _this7.getUrlParams(endpoint);
          var datatext = _this7.datatext;
          var fields = _this7.datatext;
          var sort = '+' + datatext;
          var keys = datatext.match(/\{[a-zA-Z_]*?\}/g);
          if (keys) {
            keys = keys.map(function (b) {
              return b.replace(/\{|(.*?)\}/g, '$1');
            });
            datatext = keys[0];
            fields = keys.join(',');
            sort = '+' + keys.join(',+');
          }
          var operator = _this7.queryOperator ? _this7.queryOperator : '^=';
          operator = _this7.dataoperator ? _this7.dataoperator : operator;
          params.filters = (params.filters ? '&' : '') + ('(' + datatext + operator + query + ')');
          params.sort = sort;
          params.fields = _this7.datavalue + ',' + fields;
          endpoint = endpoint.replace(/\?.*$/, '') + '?' + _this7.buildQueryString(params);
        }
        if (_this7.clientRequest && _this7.clientRequest.cancel) {
          _this7.clientRequest.cancel();
        }
        _this7.clientRequest = client.get(endpoint, { distinct: true });
        _this7.clientRequest.then(function (x) {
          items = _this7.parse_response(x);
          resolve(items);
        }).catch(function (x) {});
      } else if (!_this7.datapreload && value && (datasource.table || datasource.url)) {
        var _endpoint = datasource.table || datasource.url;
        if (datasource.query && _typeof(datasource.query) === 'object' && datasource.query.item) {
          _endpoint = _this7.addUrlParam(_endpoint, datasource.query.item, value);
        } else if (datasource.query && typeof datasource.query === 'string') {
          _endpoint = _this7.addUrlParam(_endpoint, datasource.query, value);
        } else {
          var _params = _this7.getUrlParams(_endpoint);
          var _fields = _this7.datatext;
          var _keys = _fields.match(/\{[a-zA-Z_]*?\}/g);
          if (_keys) _fields = _keys.join(',').replace(/\{|\}/g, '');
          _params.filters = (_params.filters ? '&' : '') + ('(' + _this7.datavalue + '=' + value + ')');
          _params.fields = _this7.datavalue + ',' + _fields;
          _endpoint = _endpoint.replace(/\?.*$/, '') + '?' + _this7.buildQueryString(_params);
        }

        _this7.clientRequest = client.get(_endpoint, { distinct: true });
        _this7.clientRequest.then(function (x) {
          items = _this7.parse_response(x);
          resolve(items);
        }).catch(function (x) {});
      }
    });
  };

  KaInputControls.prototype.comboDisplayValue = function comboDisplayValue() {
    var _this8 = this;

    if (!this.value) {
      if (this.buttons && this.buttons.length > 0 && this.control === 'combo' && this.datasource && this.datasource.table && !this.datamultiple) {
        this.buttons.openEnabled = false;
        this.buttons.addEnabled = !this.element.classList.contains('no-add');
      }
      return this.displayValue = null;
    }
    if (this.buttons && this.buttons.length > 0 && this.control === 'combo' && this.datasource && this.datasource.table && !this.datamultiple) {
      this.buttons.openEnabled = !this.element.classList.contains('no-open');
      this.buttons.addEnabled = false;
    }
    if (this.datamultiple) {
      var _ret = function () {
        var datatexts = [];
        var parsed = 0;
        if (!_this8.value.length) {
          _this8.comboValueReady();
          return {
            v: _this8.displayValue = null
          };
        }

        var _loop = function _loop() {
          if (_isArray) {
            if (_i >= _iterator.length) return 'break';
            _ref = _iterator[_i++];
          } else {
            _i = _iterator.next();
            if (_i.done) return 'break';
            _ref = _i.value;
          }

          var item = _ref;

          parsed++;

          var v = typeof item === 'string' || typeof item === 'number' ? String(item) : String(item[_this8.datavalue]) ? String(item[_this8.datavalue]) : null;
          _this8.comboGetItems(null, v).then(function (items) {
            if (items.length === 1) {
              if ((typeof item === 'undefined' ? 'undefined' : _typeof(item)) === 'object') item = v;
              var keys = _this8.datatext.match(/\{[a-zA-Z_]*?\}/g);
              if (keys) {
                var datatext = _this8.datatext;
                for (var _iterator2 = keys, _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();;) {
                  var _ref2;

                  if (_isArray2) {
                    if (_i2 >= _iterator2.length) break;
                    _ref2 = _iterator2[_i2++];
                  } else {
                    _i2 = _iterator2.next();
                    if (_i2.done) break;
                    _ref2 = _i2.value;
                  }

                  var key = _ref2;

                  datatext = datatext.replace(key, items[0][key.replace(/\{|\}/g, '')] || '');
                }
                datatexts.push(datatext);
              } else datatexts.push(items[0][_this8.datatext] ? items[0][_this8.datatext] : eval('items[0].' + _this8.datatext) ? eval('items[0].' + _this8.datatext) : 'undefined');
            } else {
              item = null;
            }
            if (_this8.value.length === parsed) {
              _this8.displayValue = datatexts.join(', ');
            }
            _this8.comboValueReady();
          });
        };

        for (var _iterator = _this8.value, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
          var _ref;

          var _ret2 = _loop();

          if (_ret2 === 'break') break;
        }
      }();

      if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
    } else {
      if (this.comboItems) {
        var items = this.comboItems.filter(function (x) {
          return String(x[_this8.datavalue]) == String(_this8.value);
        });
        if (items && items[0]) {
          this.objectValue = items[0];
          var keys = this.datatext.match(/\{[a-zA-Z_]*?\}/g);
          if (keys) {
            var datatext = this.datatext;
            for (var _iterator3 = keys, _isArray3 = Array.isArray(_iterator3), _i3 = 0, _iterator3 = _isArray3 ? _iterator3 : _iterator3[Symbol.iterator]();;) {
              var _ref3;

              if (_isArray3) {
                if (_i3 >= _iterator3.length) break;
                _ref3 = _iterator3[_i3++];
              } else {
                _i3 = _iterator3.next();
                if (_i3.done) break;
                _ref3 = _i3.value;
              }

              var key = _ref3;

              datatext = datatext.replace(key, items[0][key.replace(/\{|\}/g, '')] || '');
            }
            this.displayValue = datatext;
          } else this.displayValue = items[0][this.datatext] ? items[0][this.datatext] : eval('items[0].' + this.datatext) ? eval('items[0].' + this.datatext) : 'undefined';
          this.comboValueReady();
          return;
        }
      }
      var _v = typeof this.value === 'string' || typeof this.value === 'number' ? String(this.value) : String(this.value[this.datavalue]) ? String(this.value[this.datavalue]) : null;
      this.comboGetItems(null, _v).then(function (items) {
        if (items.length === 1) {
          _this8.objectValue = items[0];
          if (_typeof(_this8.value) === 'object') _this8.value = _v;
          var _keys2 = _this8.datatext.match(/\{[a-zA-Z_]*?\}/g);
          if (_keys2) {
            var _datatext = _this8.datatext;
            for (var _iterator4 = _keys2, _isArray4 = Array.isArray(_iterator4), _i4 = 0, _iterator4 = _isArray4 ? _iterator4 : _iterator4[Symbol.iterator]();;) {
              var _ref4;

              if (_isArray4) {
                if (_i4 >= _iterator4.length) break;
                _ref4 = _iterator4[_i4++];
              } else {
                _i4 = _iterator4.next();
                if (_i4.done) break;
                _ref4 = _i4.value;
              }

              var _key = _ref4;

              _datatext = _datatext.replace(_key, items[0][_key.replace(/\{|\}/g, '')] || '');
            }
            _this8.displayValue = _datatext;
          } else _this8.displayValue = items[0][_this8.datatext] ? items[0][_this8.datatext] : eval('items[0].' + _this8.datatext) ? eval('items[0].' + _this8.datatext) : 'undefined';
          _this8.comboValueReady();
        } else {
          _this8.value = null;
          _this8.displayValue = null;
          _this8.objectValue = null;
          _this8.comboValueReady();
        }
      });
    }
  };

  KaInputControls.prototype.comboValueReady = function comboValueReady() {
    if (!this._ready) {
      this._ready = true;
      if (typeof this.ready === 'function') this.ready(this);
    }
  };

  KaInputControls.prototype.comboSelect = function comboSelect(item, $event) {
    if (!this.datamultiple) {
      this.value = String(item[this.datavalue]);
      this.comboParseSelected();
      this.comboClose();
      this.validate();
    } else {
        if (!this.value || !Array.isArray(this.value)) this.value = [];

        if (this.value.length && this.value.indexOf(String(item[this.datavalue])) >= 0) this.value.splice(this.value.indexOf(String(item[this.datavalue])), 1);else this.value.push(String(item[this.datavalue]));

        this.comboParseSelected();
        this.validate();
      }
  };

  KaInputControls.prototype.comboParseSelected = function comboParseSelected() {
    var _this9 = this;

    for (var _iterator5 = this.comboItems, _isArray5 = Array.isArray(_iterator5), _i5 = 0, _iterator5 = _isArray5 ? _iterator5 : _iterator5[Symbol.iterator]();;) {
      var _ref5;

      if (_isArray5) {
        if (_i5 >= _iterator5.length) break;
        _ref5 = _iterator5[_i5++];
      } else {
        _i5 = _iterator5.next();
        if (_i5.done) break;
        _ref5 = _i5.value;
      }

      var _item2 = _ref5;
      _item2.selected = false;
    }if (!this.value) return;

    if (this.datamultiple) {
      var _loop2 = function _loop2() {
        if (_isArray6) {
          if (_i6 >= _iterator6.length) return 'break';
          _ref6 = _iterator6[_i6++];
        } else {
          _i6 = _iterator6.next();
          if (_i6.done) return 'break';
          _ref6 = _i6.value;
        }

        var value = _ref6;

        var item = _this9.comboItems.filter(function (x) {
          return String(x[_this9.datavalue]) === String(value);
        });
        if (item && item[0]) item[0].selected = true;
      };

      for (var _iterator6 = this.value, _isArray6 = Array.isArray(_iterator6), _i6 = 0, _iterator6 = _isArray6 ? _iterator6 : _iterator6[Symbol.iterator]();;) {
        var _ref6;

        var _ret3 = _loop2();

        if (_ret3 === 'break') break;
      }
    } else {
        var _item = this.comboItems.filter(function (x) {
          return String(x[_this9.datavalue]) === String(_this9.value);
        });
        if (_item && _item[0]) _item[0].selected = true;
      }
    this.comboDisplayValue();
  };

  KaInputControls.prototype.comboListAddItem = function comboListAddItem(item, $event) {
    this.comboListItems.push({ value: item[this.datavalue], text: item[this.datatext] });
    this.comboListItems.sort(function (a, b) {
      if (a.text < b.text) return -1;if (a.text > b.text) return 1;return 0;
    });
    this.value = this.comboListItems.map(function (x) {
      return x.value;
    });
    console.info('comboListAddItem', this.comboListItems, this.value);
    this.validate();
    this.comboClose();
  };

  KaInputControls.prototype.comboListRemoveItem = function comboListRemoveItem(item, $event) {
    this.comboListItems.splice(this.comboListItems.indexOf(item), 1);
    this.value = this.comboListItems.map(function (x) {
      return x.value;
    });
    console.info('comboListRemoveItem', this.comboListItems, this.value);
    this.validate();
  };

  KaInputControls.prototype.comboListUpdate = function comboListUpdate() {
    var _this10 = this;

    if (!this.value) return;
    if (!Array.isArray(this.value)) this.value = [this.value];
    this.value.forEach(function (item) {
      var listItem = { value: null, text: null };
      if (['number', 'string'].indexOf(typeof item === 'undefined' ? 'undefined' : _typeof(item)) > -1) listItem = { value: item, text: item };else if (item[_this10.datavalue] && item[_this10.datatext]) listItem = { value: item[_this10.datavalue], text: item[_this10.datatext] };else if (item.value && item.text) listItem = Object.assign({}, item);
      if (_this10.comboListItems.filter(function (x) {
        return x.value === listItem.value;
      }).length === 0) _this10.comboListItems.push(listItem);
    });
    this.comboListItems.sort(function (a, b) {
      if (a.text < b.text) return -1;if (a.text > b.text) return 1;return 0;
    });
  };

  KaInputControls.prototype.checklistInit = function checklistInit() {
    var _this11 = this;

    if (Array.isArray(this.datasource)) {
      this.checklistItems = JSON.parse(JSON.stringify(this.datasource));
      this.checklistParseSelected();
    } else {
      var client = !this.client || this.datasource.url ? this._client : this.client;
      client.get(this.datasource.table || this.datasource.url).then(function (x) {
        _this11.checklistItems = _this11.parse_response(x);
        _this11.checklistParseSelected();
      }).catch(function (x) {});
    }
  };

  KaInputControls.prototype.checklistSelect = function checklistSelect(item, $event) {
    if (this.readonly) return;
    if (!this.value || !Array.isArray(this.value)) this.value = [];

    if (this.value.length && this.value.indexOf(String(item[this.datavalue])) >= 0) this.value.splice(this.value.indexOf(String(item[this.datavalue])), 1);else this.value.push(String(item[this.datavalue]));

    this.checklistParseSelected();
    this.validate();
  };

  KaInputControls.prototype.checklistParseSelected = function checklistParseSelected() {
    var _this12 = this;

    if (!this.checklistItems) return;
    for (var _iterator7 = this.checklistItems, _isArray7 = Array.isArray(_iterator7), _i7 = 0, _iterator7 = _isArray7 ? _iterator7 : _iterator7[Symbol.iterator]();;) {
      var _ref7;

      if (_isArray7) {
        if (_i7 >= _iterator7.length) break;
        _ref7 = _iterator7[_i7++];
      } else {
        _i7 = _iterator7.next();
        if (_i7.done) break;
        _ref7 = _i7.value;
      }

      var _item3 = _ref7;
      _item3.selected = false;
    }if (!this.value) return;

    var _loop3 = function _loop3() {
      if (_isArray8) {
        if (_i8 >= _iterator8.length) return 'break';
        _ref8 = _iterator8[_i8++];
      } else {
        _i8 = _iterator8.next();
        if (_i8.done) return 'break';
        _ref8 = _i8.value;
      }

      var value = _ref8;

      var item = _this12.checklistItems.filter(function (x) {
        return String(x[_this12.datavalue]) == String(value);
      });
      if (item && item[0]) item[0].selected = true;
    };

    for (var _iterator8 = this.value, _isArray8 = Array.isArray(_iterator8), _i8 = 0, _iterator8 = _isArray8 ? _iterator8 : _iterator8[Symbol.iterator]();;) {
      var _ref8;

      var _ret4 = _loop3();

      if (_ret4 === 'break') break;
    }
  };

  KaInputControls.prototype.parse_response = function parse_response(msg) {
    if (msg.responseType === 'json' && typeof msg.response === 'string') msg.response = JSON.parse(msg.response);
    return msg.response;
  };

  KaInputControls.prototype.getUrlParams = function getUrlParams(url) {
    url = url.replace(/^.*(\?|$)/, '');
    if (!url[1]) return {};
    var chunks = url[1].split('&');
    return chunks.reduce(function (params, hash) {
      var _Object$assign;

      var _hash$split = hash.split('='),
          key = _hash$split[0],
          val = _hash$split[1];

      return Object.assign(params, (_Object$assign = {}, _Object$assign[key] = decodeURIComponent(val), _Object$assign));
    }, {});
  };

  KaInputControls.prototype.addUrlParams = function addUrlParams(url, params) {
    if (!params) return url;
    for (var _iterator9 = Object.entries(params), _isArray9 = Array.isArray(_iterator9), _i9 = 0, _iterator9 = _isArray9 ? _iterator9 : _iterator9[Symbol.iterator]();;) {
      var _ref9;

      if (_isArray9) {
        if (_i9 >= _iterator9.length) break;
        _ref9 = _iterator9[_i9++];
      } else {
        _i9 = _iterator9.next();
        if (_i9.done) break;
        _ref9 = _i9.value;
      }

      var _ref10 = _ref9,
          k = _ref10[0],
          _v2 = _ref10[1];

      url = this.addUrlParam(url, k, _v2);
    }
    return url;
  };

  KaInputControls.prototype.addUrlParam = function addUrlParam(url, key, value) {
    if (!key || !value) return url;
    url = new URL((!url.startsWith('http') ? 'void://' : '') + url);
    var urlParams = new URLSearchParams(url.search);
    urlParams.append(key, value);
    url.search = urlParams;
    return url.toString().replace('void://', '');
  };

  KaInputControls.prototype.buildQueryString = function buildQueryString(params) {
    return Object.keys(params).reduce(function (query, key) {
      return query + '&' + key + '=' + encodeURIComponent(params[key]);
    }, '').replace(/^\&/, '');
  };

  return KaInputControls;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'value', [_dec4], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'displayValue', [_dec5], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'objectValue', [_dec6], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, 'config', [_dec7], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, 'record', [_dec8], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, 'name', [_dec9], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, 'label', [_dec10], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, 'default', [_dec11], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, 'required', [_dec12], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, 'readonly', [_dec13], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, 'control', [_dec14], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, 'client', [_dec15], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, 'description', [_dec16], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, 'validation', [_dec17], {
  enumerable: true,
  initializer: function initializer() {
    return true;
  }
}), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, 'queryOperator', [_dec18], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, 'change', [_dec19], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor17 = _applyDecoratedDescriptor(_class2.prototype, 'ready', [_dec20], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor18 = _applyDecoratedDescriptor(_class2.prototype, 'dialogClosed', [_dec21], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor19 = _applyDecoratedDescriptor(_class2.prototype, 'comboListItems', [_dec22], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
})), _class2)) || _class) || _class) || _class);

var kaHighlightValueConverter = exports.kaHighlightValueConverter = function () {
  function kaHighlightValueConverter() {
    _classCallCheck(this, kaHighlightValueConverter);
  }

  kaHighlightValueConverter.prototype.toView = function toView(item, datatext, string) {
    var value = null;
    var keys = datatext.match(/\{[a-zA-Z_]*?\}/g);
    if (keys) {
      for (var _iterator10 = keys, _isArray10 = Array.isArray(_iterator10), _i10 = 0, _iterator10 = _isArray10 ? _iterator10 : _iterator10[Symbol.iterator]();;) {
        var _ref11;

        if (_isArray10) {
          if (_i10 >= _iterator10.length) break;
          _ref11 = _iterator10[_i10++];
        } else {
          _i10 = _iterator10.next();
          if (_i10.done) break;
          _ref11 = _i10.value;
        }

        var key = _ref11;

        datatext = datatext.replace(key, item[key.replace(/\{|\}/g, '')] || '');
      }
      value = datatext;
    } else value = item[datatext] ? item[datatext] : eval('item.' + datatext) ? eval('item.' + datatext) : null;
    if (!value) return;
    if (!string || !string.length) return value;
    var index = value.toLowerCase().indexOf(string.toLowerCase());
    if (index >= 0) value = value.substring(0, index) + '<strong>' + value.substring(index, index + string.length) + '</strong>' + value.substring(index + string.length);
    return value;
  };

  return kaHighlightValueConverter;
}();