'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.KaInput = undefined;

var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _dec17, _dec18, _dec19, _dec20, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _descriptor17, _descriptor18;

var _aureliaFramework = require('aurelia-framework');

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var KaInput = exports.KaInput = (_dec = (0, _aureliaFramework.customElement)('ka-input'), _dec2 = (0, _aureliaFramework.inject)(Element), _dec3 = (0, _aureliaFramework.bindable)({ defaultBindingMode: _aureliaFramework.bindingMode.twoWay }), _dec4 = (0, _aureliaFramework.bindable)(), _dec5 = (0, _aureliaFramework.bindable)(), _dec6 = (0, _aureliaFramework.bindable)(), _dec7 = (0, _aureliaFramework.bindable)(), _dec8 = (0, _aureliaFramework.bindable)(), _dec9 = (0, _aureliaFramework.bindable)(), _dec10 = (0, _aureliaFramework.bindable)(), _dec11 = (0, _aureliaFramework.bindable)(), _dec12 = (0, _aureliaFramework.bindable)(), _dec13 = (0, _aureliaFramework.bindable)(), _dec14 = (0, _aureliaFramework.bindable)(), _dec15 = (0, _aureliaFramework.bindable)(), _dec16 = (0, _aureliaFramework.bindable)(), _dec17 = (0, _aureliaFramework.bindable)(), _dec18 = (0, _aureliaFramework.bindable)(), _dec19 = (0, _aureliaFramework.bindable)({ defaultBindingMode: _aureliaFramework.bindingMode.twoWay }), _dec20 = (0, _aureliaFramework.bindable)(), _dec(_class = _dec2(_class = (_class2 = function () {
  function KaInput(element) {
    _classCallCheck(this, KaInput);

    _initDefineProp(this, 'value', _descriptor, this);

    _initDefineProp(this, 'config', _descriptor2, this);

    _initDefineProp(this, 'record', _descriptor3, this);

    _initDefineProp(this, 'name', _descriptor4, this);

    _initDefineProp(this, 'label', _descriptor5, this);

    _initDefineProp(this, 'default', _descriptor6, this);

    _initDefineProp(this, 'required', _descriptor7, this);

    _initDefineProp(this, 'readonly', _descriptor8, this);

    _initDefineProp(this, 'control', _descriptor9, this);

    _initDefineProp(this, 'client', _descriptor10, this);

    _initDefineProp(this, 'description', _descriptor11, this);

    _initDefineProp(this, 'change', _descriptor12, this);

    _initDefineProp(this, 'ready', _descriptor13, this);

    _initDefineProp(this, 'dialogClosed', _descriptor14, this);

    _initDefineProp(this, 'validation', _descriptor15, this);

    _initDefineProp(this, 'queryOperator', _descriptor16, this);

    _initDefineProp(this, 'resourceControls', _descriptor17, this);

    _initDefineProp(this, 'resourceRef', _descriptor18, this);

    this.insideMdResource = null;

    this.element = element;
  }

  KaInput.prototype.bind = function bind(bindingContext) {
    this.parent = bindingContext;
    if (bindingContext) {
      this.insideMdResource = !!(this.name && bindingContext.constructor.name === 'MdResource' && bindingContext.controls);
    }
  };

  KaInput.prototype.attached = function attached() {
    if (this.resourceControls && this.resourceRef && this.input) {
      this.resourceControls[this.resourceRef] = this.input;
    }
  };

  KaInput.prototype.resourceControlsChanged = function resourceControlsChanged(resourceControls) {
    if (this.resourceControls && this.input) {
      this.resourceControls = this.input;
    }
  };

  return KaInput;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'value', [_dec3], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'config', [_dec4], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'record', [_dec5], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, 'name', [_dec6], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, 'label', [_dec7], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, 'default', [_dec8], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, 'required', [_dec9], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, 'readonly', [_dec10], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, 'control', [_dec11], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, 'client', [_dec12], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, 'description', [_dec13], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, 'change', [_dec14], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, 'ready', [_dec15], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, 'dialogClosed', [_dec16], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, 'validation', [_dec17], {
  enumerable: true,
  initializer: function initializer() {
    return true;
  }
}), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, 'queryOperator', [_dec18], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor17 = _applyDecoratedDescriptor(_class2.prototype, 'resourceControls', [_dec19], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor18 = _applyDecoratedDescriptor(_class2.prototype, 'resourceRef', [_dec20], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
})), _class2)) || _class) || _class);