'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.KaTableFilters = undefined;

var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4;

var _aureliaFramework = require('aurelia-framework');

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var KaTableFilters = exports.KaTableFilters = (_dec = (0, _aureliaFramework.customElement)('ka-table-filters'), _dec2 = (0, _aureliaFramework.containerless)(), _dec3 = (0, _aureliaFramework.inject)(Element), _dec4 = (0, _aureliaFramework.bindable)(), _dec5 = (0, _aureliaFramework.bindable)({ defaultBindingMode: _aureliaFramework.bindingMode.twoWay }), _dec6 = (0, _aureliaFramework.bindable)(), _dec7 = (0, _aureliaFramework.bindable)(), _dec(_class = _dec2(_class = _dec3(_class = (_class2 = function () {
  function KaTableFilters(element) {
    _classCallCheck(this, KaTableFilters);

    _initDefineProp(this, 'schema', _descriptor, this);

    _initDefineProp(this, 'filters', _descriptor2, this);

    _initDefineProp(this, 'apply', _descriptor3, this);

    _initDefineProp(this, 'reset', _descriptor4, this);

    this._schema = null;

    this.element = element;
  }

  KaTableFilters.prototype.schemaChanged = function schemaChanged(schema) {
    schema = JSON.parse(JSON.stringify(schema));

    if (!schema) {
      konsole.warn('ka-table-filters: missing schema!', schema);
      return;
    }
    if (typeof schema === 'string') {
      try {
        schema = JSON.parse(schema);
      } catch (error) {
        konsole.error('ka-table-filters: invalid schema provided!', schema);
        return;
      }
    }
    if (!Array.isArray(schema) || !schema.length) {
      konsole.error('ka-table-filters: schema must be an array of objects!', schema);
      return;
    }

    for (var _iterator = schema, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
      var _ref;

      if (_isArray) {
        if (_i >= _iterator.length) break;
        _ref = _iterator[_i++];
      } else {
        _i = _iterator.next();
        if (_i.done) break;
        _ref = _i.value;
      }

      var item = _ref;

      item.placeholder = 'Filtra per ' + item.label.toLowerCase();
      item.label = null;
      item.required = false;
    }

    konsole.debug('ka-table-filters: schema changed!', schema);
    this._schema = schema;
  };

  return KaTableFilters;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'schema', [_dec4], {
  enumerable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'filters', [_dec5], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'apply', [_dec6], {
  enumerable: true,
  initializer: function initializer() {
    return function () {};
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, 'reset', [_dec7], {
  enumerable: true,
  initializer: function initializer() {
    return function () {};
  }
})), _class2)) || _class) || _class) || _class);