
import environment from 'environment';

export let KaConsole = class KaConsole {

  log() {
    this.debug(Object.values(arguments));
  }
  debug() {
    if (!environment.debug) return;
    console.debug.apply(console, ['%cK#DEBUG', 'background-color:#cbf7da;padding:5px;line-height:1;border-radius:3px;'].concat(Object.values(arguments)));
  }
  info() {
    console.info.apply(console, ['%cK#INFO', 'background-color:#cbecf7;padding:5px;line-height:1;border-radius:3px;'].concat(Object.values(arguments)));
  }
  warn() {
    console.warn.apply(console, ['%cK#WARN', 'background-color:#f7e8cb;padding:5px;line-height:1;border-radius:3px;'].concat(Object.values(arguments)));
  }
  error() {
    console.error.apply(console, ['%cK#ERROR', 'background-color:#f7cbcb;padding:5px;line-height:1;border-radius:3px;'].concat(Object.values(arguments)));
  }
};