var _dec, _dec2, _dec3, _dec4, _dec5, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3;

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import { inject, customElement, bindable, bindingMode } from 'aurelia-framework';
import { Router } from 'aurelia-router';

export let KaControlsTable = (_dec = customElement('ka-control-table'), _dec2 = inject(Element, Router), _dec3 = bindable(), _dec4 = bindable({ defaultBindingMode: bindingMode.twoWay }), _dec5 = bindable(), _dec(_class = _dec2(_class = (_class2 = class KaControlsTable {

  constructor(element, router) {
    _initDefineProp(this, 'schema', _descriptor, this);

    _initDefineProp(this, 'value', _descriptor2, this);

    _initDefineProp(this, 'label', _descriptor3, this);

    this._schema = null;
    this._value = [];
    this.newValue = {};

    this.element = element;
    this.router = router;
  }

  attached() {}

  schemaChanged(schema) {
    if (!schema) {
      konsole.warn('ka-control-table: missing schema!', schema);
      return;
    }
    if (typeof schema === 'string') {
      try {
        schema = JSON.parse(schema);
      } catch (error) {
        konsole.error('ka-control-table: invalid schema provided!', value);
        return;
      }
    }
    if (!Array.isArray(schema) || !schema.length) {
      konsole.error('ka-control-table: schema must be an array of objects!', schema);
      return;
    }
    konsole.debug('ka-control-table: schema changed!', schema);
    this._schema = schema;
  }

  valueChanged(value) {
    if (!value || value === JSON.stringify(this._value)) {
      return;
    }
    if (typeof value === 'string') {
      try {
        value = JSON.parse(value);
      } catch (error) {
        konsole.error('ka-control-table: invalid value provided!', value);
        return;
      }
    }
    if (!Array.isArray(value)) {
      konsole.error('ka-control-table: value must be an array!', value);
      return;
    }
    this._value = value;
  }

  update() {
    this.value = JSON.stringify(this._value);
  }

  add(value) {
    this.newValue = {};
    this._value.push(value);
    this.update();
  }

  remove(value) {
    this._value = this._value.filter(v => v !== value);
    this.update();
  }
}, (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'schema', [_dec3], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'value', [_dec4], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'label', [_dec5], {
  enumerable: true,
  initializer: function () {
    return null;
  }
})), _class2)) || _class) || _class);