var _dec, _dec2, _class;

import { inject, customAttribute } from 'aurelia-framework';

export let KaTooltipCustomAttribute = (_dec = customAttribute('ka-tooltip'), _dec2 = inject(Element), _dec(_class = _dec2(_class = class KaTooltipCustomAttribute {

  constructor(element) {
    this.element = element;
  }

  attached() {
    this.element.addEventListener('mouseover', e => {
      if (this.tooltip) return;
      let bounds = e.target.getBoundingClientRect();
      this.tooltip = document.createElement('div');
      this.tooltip.classList.add('ka-tooltip');
      this.tooltip.style.top = bounds.top + bounds.height + 'px';
      this.tooltip.style.left = bounds.left + bounds.width / 2 + 'px';
      this.tooltip.innerHTML = this.value;
      document.getElementsByTagName('body')[0].insertBefore(this.tooltip, document.getElementsByTagName('body')[0].children[0]);
      setTimeout(() => {
        if (!this.tooltip) return;this.tooltip.classList.add('visible');
      }, 1000);
    });
    this.element.addEventListener('mouseout', e => {
      if (!this.tooltip) return;
      document.getElementsByTagName('body')[0].removeChild(this.tooltip);
      this.tooltip = null;
    });
  }
  detached() {
    if (!this.tooltip) return;
    document.getElementsByTagName('body')[0].removeChild(this.tooltip);
    this.tooltip = null;
  }
}) || _class) || _class);