'use strict';

System.register(['aurelia-framework', 'aurelia-dialog'], function (_export, _context) {
  "use strict";

  var inject, DialogController, _dec, _class, KaDialogVm;

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  return {
    setters: [function (_aureliaFramework) {
      inject = _aureliaFramework.inject;
    }, function (_aureliaDialog) {
      DialogController = _aureliaDialog.DialogController;
    }],
    execute: function () {
      _export('KaDialogVm', KaDialogVm = (_dec = inject(DialogController), _dec(_class = function () {
        function KaDialogVm(controller) {
          _classCallCheck(this, KaDialogVm);

          this.controller = controller;
        }

        KaDialogVm.prototype.activate = function activate(params) {
          var classes = params.viewModel ? ['viewModel'] : [''];
          params.class = params.class ? classes.concat(params.class.split(' ')).join(' ') : classes.join(' ');
          this.params = params;
          if (this.params.viewModel && this.params.viewModelParams) this.params.viewModelParams.dialog = this.controller;
        };

        return KaDialogVm;
      }()) || _class));

      _export('KaDialogVm', KaDialogVm);
    }
  };
});