define(['exports', 'aurelia-framework', 'aurelia-dialog'], function (exports, _aureliaFramework, _aureliaDialog) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.KaDialogVm = undefined;

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _dec, _class;

  var KaDialogVm = exports.KaDialogVm = (_dec = (0, _aureliaFramework.inject)(_aureliaDialog.DialogController), _dec(_class = function () {
    function KaDialogVm(controller) {
      _classCallCheck(this, KaDialogVm);

      this.controller = controller;
    }

    KaDialogVm.prototype.activate = function activate(params) {
      var classes = params.viewModel ? ['viewModel'] : [''];
      params.class = params.class ? classes.concat(params.class.split(' ')).join(' ') : classes.join(' ');
      this.params = params;
      if (this.params.viewModel && this.params.viewModelParams) this.params.viewModelParams.dialog = this.controller;
    };

    return KaDialogVm;
  }()) || _class);
});