define(['exports', 'aurelia-framework', 'aurelia-router', '../ka-dialog/ka-dialog', '../ka-toast/ka-toast', 'moment'], function (exports, _aureliaFramework, _aureliaRouter, _kaDialog, _kaToast, _moment) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.KaTable = undefined;

  var _moment2 = _interopRequireDefault(_moment);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _initDefineProp(target, property, descriptor, context) {
    if (!descriptor) return;
    Object.defineProperty(target, property, {
      enumerable: descriptor.enumerable,
      configurable: descriptor.configurable,
      writable: descriptor.writable,
      value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
    });
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
    var desc = {};
    Object['ke' + 'ys'](descriptor).forEach(function (key) {
      desc[key] = descriptor[key];
    });
    desc.enumerable = !!desc.enumerable;
    desc.configurable = !!desc.configurable;

    if ('value' in desc || desc.initializer) {
      desc.writable = true;
    }

    desc = decorators.slice().reverse().reduce(function (desc, decorator) {
      return decorator(target, property, desc) || desc;
    }, desc);

    if (context && desc.initializer !== void 0) {
      desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
      desc.initializer = undefined;
    }

    if (desc.initializer === void 0) {
      Object['define' + 'Property'](target, property, desc);
      desc = null;
    }

    return desc;
  }

  function _initializerWarningHelper(descriptor, context) {
    throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
  }

  var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _dec17, _dec18, _dec19, _dec20, _dec21, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _descriptor17, _descriptor18, _descriptor19;

  var KaTable = exports.KaTable = (_dec = (0, _aureliaFramework.customElement)('ka-table'), _dec2 = (0, _aureliaFramework.inject)(Element, _aureliaRouter.Router, _kaDialog.KaDialog, _kaToast.KaToast), _dec3 = (0, _aureliaFramework.bindable)(), _dec4 = (0, _aureliaFramework.bindable)(), _dec5 = (0, _aureliaFramework.bindable)(), _dec6 = (0, _aureliaFramework.bindable)(), _dec7 = (0, _aureliaFramework.bindable)(), _dec8 = (0, _aureliaFramework.bindable)(), _dec9 = (0, _aureliaFramework.bindable)(), _dec10 = (0, _aureliaFramework.bindable)(), _dec11 = (0, _aureliaFramework.bindable)(), _dec12 = (0, _aureliaFramework.bindable)(), _dec13 = (0, _aureliaFramework.bindable)(), _dec14 = (0, _aureliaFramework.bindable)(), _dec15 = (0, _aureliaFramework.bindable)(), _dec16 = (0, _aureliaFramework.bindable)(), _dec17 = (0, _aureliaFramework.bindable)(), _dec18 = (0, _aureliaFramework.bindable)(), _dec19 = (0, _aureliaFramework.bindable)(), _dec20 = (0, _aureliaFramework.bindable)(), _dec21 = (0, _aureliaFramework.bindable)(), _dec(_class = _dec2(_class = (_class2 = function () {
    function KaTable(element, router, dialog, toast) {
      _classCallCheck(this, KaTable);

      _initDefineProp(this, 'records', _descriptor, this);

      _initDefineProp(this, 'schema', _descriptor2, this);

      _initDefineProp(this, 'export_schema', _descriptor3, this);

      _initDefineProp(this, 'columns_schema', _descriptor4, this);

      _initDefineProp(this, 'filters', _descriptor5, this);

      _initDefineProp(this, 'endpoint', _descriptor6, this);

      _initDefineProp(this, 'limit', _descriptor7, this);

      _initDefineProp(this, 'depth', _descriptor8, this);

      _initDefineProp(this, 'client', _descriptor9, this);

      _initDefineProp(this, 'columns', _descriptor10, this);

      _initDefineProp(this, 'filtrables', _descriptor11, this);

      _initDefineProp(this, 'sortables', _descriptor12, this);

      _initDefineProp(this, 'editables', _descriptor13, this);

      _initDefineProp(this, 'exportables', _descriptor14, this);

      _initDefineProp(this, 'prefilter', _descriptor15, this);

      _initDefineProp(this, 'routes', _descriptor16, this);

      _initDefineProp(this, 'actions', _descriptor17, this);

      _initDefineProp(this, 'params', _descriptor18, this);

      _initDefineProp(this, 'query', _descriptor19, this);

      this.schema_loaded = function () {};

      this.filters_loaded = function () {};

      this.parse_query = function (query) {
        return query;
      };

      this.records_loaded = function () {};

      this.id = null;
      this.settings = {
        filters: null,
        exports: null,
        sort: {},
        sort_stack: [],
        sort_columns: {},
        offset: 0,
        limit: '10'
      };
      this.config_operators = {
        text: {
          field: 'operator',
          control: 'combo',
          datapreload: true,
          datasource: [{ value: '=', text: 'Uguale a' }, { value: '!=', text: 'Diverso da' }, { value: '^=', text: 'Inizia con' }, { value: '~', text: 'Contiene' }, { value: '!~', text: 'Non contiene' }]
        },
        json: {
          field: 'operator',
          control: 'combo',
          datapreload: true,
          datasource: [{ value: '~', text: 'Contiene' }]
        },
        number: {
          field: 'operator',
          control: 'combo',
          datapreload: true,
          datasource: [{ value: '=', text: 'Uguale a' }, { value: '!=', text: 'Diverso da' }, { value: '>=', text: 'Maggiore uguale a' }, { value: '<=', text: 'Minore uguale a' }]
        }
      };
      this.config_metas = [{ field: 'id', label: 'Id', control: 'number' }, { field: 'date_created', label: 'Data creazione', control: 'date' }, { field: 'user_created', label: 'Creato da', control: 'number' }, { field: 'date_modified', label: 'Data ultima modifica', control: 'date' }, { field: 'user_modified', label: 'Modificato da', control: 'number' }];
      this.config_options = {
        limit: { field: 'option-limit', label: 'Record per pagina', control: 'combo', datapreload: true, datasource: [{ value: '10', text: '10' }, { value: '25', text: '25' }, { value: '50', text: '50' }, { value: '100', text: '100' }, { value: '200', text: '200' }] },
        pages: { field: 'option-pages', label: 'Salta alla pagina', control: 'combo', datapreload: true, datasource: [] }
      };
      this.position = null;
      this.hasFilters = false;
      this.isLoading = true;
      this.schemaLoaded = false;
      this.error = null;

      this.element = element;
      this.router = router;
      this.dialog = dialog;
      this.toast = toast;
    }

    KaTable.prototype.bind = function bind(bindingContext, overrideContext) {
      this.parent = bindingContext;
    };

    KaTable.prototype.detached = function detached() {
      this.hide_options();
      this.hide_filters();
      window.removeEventListener('resize', window['ka-table-resize-handler-' + this.id]);
      delete window['ka-table-resize-handler-' + this.id];
    };

    KaTable.prototype.attached = function attached() {
      if (!this.endpoint && this.parent.endpoint) this.endpoint = this.parent.endpoint;
      if (!this.client && this.parent.api && this.parent.api.client) this.client = this.parent.api.client;
      if (this.columns && typeof this.columns == 'string') this.columns = this.columns.split(',');
      if (this.filtrables && typeof this.filtrables == 'string') this.filtrables = this.filtrables.split(',');
      if (this.sortables && typeof this.sortables === 'string') this.sortables = this.sortables.split(',');
      if (this.exportables && typeof this.exportables == 'string') this.exportables = this.exportables.split(',');
      if (this.actions && typeof this.actions == 'string') this.actions = this.actions === "" ? [] : this.actions.split(',');
      if (this.limit) this.settings.limit = String(this.limit);

      var userId = this.parent.api && this.parent.api.user && this.parent.api.user.id ? this.parent.api.user.id : null;
      var appVer = this.parent.api && this.parent.api.environment && this.parent.api.environment.version ? this.parent.api.environment.version : null;
      appVer = !appVer && this.parent.environment && this.parent.environment.version ? this.parent.environment.version : appVer;

      this.id = btoa('§' + userId + '-' + appVer + '§' + this.prefilter + '§' + this.endpoint + '§' + location.pathname + '§' + (this.columns ? this.columns.join('') : '')).replace(/[\W_]+/g, '').slice(0, 120);
      this.element.setAttribute('id', this.id);

      if (localStorage.getItem(this.id)) {
        this.settings = JSON.parse(localStorage.getItem(this.id));
      } else if (sessionStorage.getItem(this.id)) {
        this.settings = JSON.parse(sessionStorage.getItem(this.id));
      }
      this.init();

      this.element.querySelector('.ka-wrapper').addEventListener('scroll', function (event) {
        event.target.querySelectorAll('.floater').forEach(function (floater) {
          floater.style.transform = 'translateX(' + event.target.scrollLeft + 'px)';
        });
      });

      eval('window[\'ka-table-resize-handler-' + this.id + '\'] = function() {\n      var element = document.querySelector(\'#' + this.id + '\');\n      if (!element) return;\n      if (element.classList.contains(\'full-height\')) {\n        element.style.height = parseInt(window.innerHeight - element.getBoundingClientRect().top) + \'px\';\n      }\n      var table = element.querySelector(\'table\');\n      table.querySelectorAll(\'tbody td.ka-tr-tools:last-child\').forEach(function (element) {\n        var floater = element.querySelector(\'.floater\');\n        if (!floater) return;\n        var h = element.getBoundingClientRect().height;\n        var w = floater.getBoundingClientRect().width;\n        if (floater && h && w) {\n          floater.classList.add(\'float\');\n          floater.style.height = h + \'px\';\n          element.style.minWidth = w + \'px\';\n        }\n      });\n    }');
      window.addEventListener('resize', window['ka-table-resize-handler-' + this.id]);
    };

    KaTable.prototype.init = function init() {
      var _this = this;

      if (!this.client || !this.endpoint) return console.warn('[mk-table] missing client or endpoint configuration');
      this.isLoading = true;
      this.error = null;
      this.hide_options();

      this.client.get('datasets/' + this.endpoint).then(function (x) {
        _this.dataset = _this.parse_response(x);
        var dataset = _this.parse_response(x);
        var promises = [];

        if (!_this.schema) {
          if (_this.columns) {
            var fields = (_this.columns || []).concat((_this.filtrables || []).filter(function (item) {
              return _this.columns.indexOf(item) < 0;
            }));
            _this.schema = [];
            _this.columns_schema = [];

            var _loop = function _loop() {
              if (_isArray) {
                if (_i >= _iterator.length) return 'break';
                _ref = _iterator[_i++];
              } else {
                _i = _iterator.next();
                if (_i.done) return 'break';
                _ref = _i.value;
              }

              var field = _ref;

              if (field.indexOf('.') > 0) {
                var parts = field.split('.');
                var fieldDataset = dataset.find(function (o) {
                  return o.field === parts[0];
                });
                var datasource = fieldDataset.datasource ? JSON.parse(fieldDataset.datasource) : null;
                if (datasource && datasource.table) {
                  var fieldSchema = { field: parts[0] + '.' + parts[1] };
                  _this.schema.push(fieldSchema);
                  if (_this.columns.includes(fieldSchema.field)) _this.columns_schema.push(fieldSchema);
                  promises.push(_this.client.get('datasets/' + datasource.table).then(function (x) {
                    var schema = _this.parse_response(x).find(function (o) {
                      return o.field === parts[1];
                    }) || {};
                    schema.field = fieldSchema.field;
                    _this.schema[_this.schema.findIndex(function (o) {
                      return o.field === fieldSchema.field;
                    })] = schema;
                    if (_this.columns.includes(fieldSchema.field)) _this.columns_schema[_this.columns_schema.findIndex(function (o) {
                      return o.field === fieldSchema.field;
                    })] = schema;
                    _this.dataset.push(schema);
                  }));
                }
              } else {
                var _fieldSchema = dataset.find(function (o) {
                  return o.field === field;
                }) || Object.assign({}, _this.config_metas.find(function (o) {
                  return o.field === field;
                }));
                _this.schema.push(_fieldSchema);
                if (_this.columns.includes(field)) _this.columns_schema.push(_fieldSchema);
              }
            };

            for (var _iterator = fields, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
              var _ref;

              var _ret = _loop();

              if (_ret === 'break') break;
            }
          } else {
            _this.columns_schema = _this.schema = dataset;
          }
        }
        Promise.all(promises).finally(function () {
          _this.schemaLoaded = true;
          _this.schema_loaded();

          for (var _iterator2 = _this.schema, _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();;) {
            var _ref2;

            if (_isArray2) {
              if (_i2 >= _iterator2.length) break;
              _ref2 = _iterator2[_i2++];
            } else {
              _i2 = _iterator2.next();
              if (_i2.done) break;
              _ref2 = _i2.value;
            }

            var column = _ref2;

            var _field2 = column.field;
            if (_field2) {
              var fieldKebab = _field2.replace(/([a-z])([A-Z])/g, '$1-$2').replace(/\s+/g, '-').toLowerCase();
              if (_this.sortables && _this.sortables.includes(_field2)) {
                _this.settings.sort_columns[_field2] = _field2;
              } else if (_this.sortables && _this.sortables.includes(fieldKebab)) {
                _this.settings.sort_columns[_field2] = fieldKebab;
              } else if (!_this.sortables) {
                _this.settings.sort_columns[_field2] = _field2;
              }
            }
          }

          if (_this.exportables && !_this.export_schema) {
            _this.export_schema = [];

            var _loop2 = function _loop2() {
              if (_isArray3) {
                if (_i3 >= _iterator3.length) return 'break';
                _ref3 = _iterator3[_i3++];
              } else {
                _i3 = _iterator3.next();
                if (_i3.done) return 'break';
                _ref3 = _i3.value;
              }

              var field = _ref3;

              var export_field = Object.assign({}, dataset.find(function (o) {
                return o.field === field;
              }) || Object.assign({}, _this.config_metas.find(function (o) {
                return o.field === field;
              })));
              _this.export_schema.push(export_field);
            };

            for (var _iterator3 = _this.exportables, _isArray3 = Array.isArray(_iterator3), _i3 = 0, _iterator3 = _isArray3 ? _iterator3 : _iterator3[Symbol.iterator]();;) {
              var _ref3;

              var _ret2 = _loop2();

              if (_ret2 === 'break') break;
            }
          } else if (!_this.export_schema) {
            _this.export_schema = [];
            for (var _iterator4 = dataset, _isArray4 = Array.isArray(_iterator4), _i4 = 0, _iterator4 = _isArray4 ? _iterator4 : _iterator4[Symbol.iterator]();;) {
              var _ref4;

              if (_isArray4) {
                if (_i4 >= _iterator4.length) break;
                _ref4 = _iterator4[_i4++];
              } else {
                _i4 = _iterator4.next();
                if (_i4.done) break;
                _ref4 = _i4.value;
              }

              var _field = _ref4;

              var export_field = Object.assign({}, _field);
              _this.export_schema.push(export_field);
            }
          }

          if (_this.filtrables && !_this.filters) {
            _this.filters = [];

            var _loop3 = function _loop3() {
              if (_isArray5) {
                if (_i5 >= _iterator5.length) return 'break';
                _ref5 = _iterator5[_i5++];
              } else {
                _i5 = _iterator5.next();
                if (_i5.done) return 'break';
                _ref5 = _i5.value;
              }

              var field = _ref5;

              var filter = Object.assign({}, dataset.find(function (o) {
                return o.field === field;
              }) || Object.assign({}, _this.config_metas.find(function (o) {
                return o.field === field;
              })));
              if (filter.control === 'combo') filter.datamultiple = true;
              if (filter.datatype === 'json') filter.control = 'text';
              if (filter.control === 'textarea' || filter.control === 'editor') filter.control = 'text';
              _this.filters.push(filter);
            };

            for (var _iterator5 = _this.filtrables, _isArray5 = Array.isArray(_iterator5), _i5 = 0, _iterator5 = _isArray5 ? _iterator5 : _iterator5[Symbol.iterator]();;) {
              var _ref5;

              var _ret3 = _loop3();

              if (_ret3 === 'break') break;
            }
          } else if (!_this.filters) {
            _this.filters = [];
            for (var _iterator6 = dataset, _isArray6 = Array.isArray(_iterator6), _i6 = 0, _iterator6 = _isArray6 ? _iterator6 : _iterator6[Symbol.iterator]();;) {
              var _ref6;

              if (_isArray6) {
                if (_i6 >= _iterator6.length) break;
                _ref6 = _iterator6[_i6++];
              } else {
                _i6 = _iterator6.next();
                if (_i6.done) break;
                _ref6 = _i6.value;
              }

              var filter = _ref6;

              filter = Object.assign({}, filter);
              if (filter.control === 'combo') filter.datamultiple = true;
              if (filter.datatype === 'json') filter.control = 'text';
              if (filter.control === 'textarea' || filter.control === 'editor') filter.control = 'text';
              _this.filters.push(filter);
            }
          }
          _this.filters_loaded();

          _this.load();
        });
      }).catch(function (error) {
        console.error(error);
        _this.isLoading = false;
        _this.records = null;
        _this.error = 'Errore nel caricamento dei dati';
      });
    };

    KaTable.prototype.load = function load() {
      var _this2 = this;

      this.isLoading = true;
      this.error = null;
      this.hide_options();

      if (!this.settings.exports) this.settings.exports = {};

      if (!this.settings.filters) this.settings.filters = {};
      for (var _iterator7 = this.filters, _isArray7 = Array.isArray(_iterator7), _i7 = 0, _iterator7 = _isArray7 ? _iterator7 : _iterator7[Symbol.iterator]();;) {
        var _ref7;

        if (_isArray7) {
          if (_i7 >= _iterator7.length) break;
          _ref7 = _iterator7[_i7++];
        } else {
          _i7 = _iterator7.next();
          if (_i7.done) break;
          _ref7 = _i7.value;
        }

        var _field4 = _ref7;

        if (!this.settings.filters[_field4.field]) {
          var default_operator = null;
          if (_field4.datamultiple) default_operator = '~~';else if (_field4.control === 'number') default_operator = '=';else if (_field4.control === 'age') default_operator = '=';
          this.settings.filters[_field4.field] = { operator: default_operator, value: null, value_from: null, value_to: null, control: _field4.control };
        }
        if (_field4.control === 'age') {
          _field4.control = 'number';
          _field4.datatype = 'tinyint(3)';
        }
      }

      var query = this.query + (this.query.indexOf('?') >= 0 ? '&' : '?') + 'meta=1';
      if (this.depth) query += '&depth=' + this.depth;
      if (this.prefilter) query += '&filters=' + encodeURIComponent(this.prefilter);
      var filters = [];

      var _loop4 = function _loop4() {
        if (_isArray8) {
          if (_i8 >= _iterator8.length) return 'break';
          _ref8 = _iterator8[_i8++];
        } else {
          _i8 = _iterator8.next();
          if (_i8.done) return 'break';
          _ref8 = _i8.value;
        }

        var field = _ref8;

        var value = _this2.settings.filters[field].value || null;
        if (value && _this2.settings.filters[field].control === 'age') {
          value = parseInt(value, 10);
          var operator = _this2.settings.filters[field].operator || null;
          if (operator === '<=') filters.push(encodeURIComponent(field + '>=' + (0, _moment2.default)().subtract(parseInt(value, 10) + 1, 'years').format('YYYY-MM-DD')));else if (operator === '>=') filters.push(encodeURIComponent(field + '<' + (0, _moment2.default)().subtract(value, 'years').format('YYYY-MM-DD')));else filters.push(encodeURIComponent(field + '<' + (0, _moment2.default)().subtract(value, 'years').format('YYYY-MM-DD') + '&' + field + '>=' + (0, _moment2.default)().subtract(value + 1, 'years').format('YYYY-MM-DD')));
        } else if (value && _this2.settings.filters[field].control === 'combo') {
          var _operator = _this2.settings.filters[field].operator || '=';
          var filter = _this2.filters.find(function (x) {
            return x.field === field;
          });
          if (filter && Array.isArray(filter.datasource)) {
            var item = filter.datasource.find(function (x) {
              return x.value === value;
            });
            if (item && item.filter_operator) _operator = item.filter_operator;
            if (item && item.filter_value) value = item.filter_value;
          }
          filters.push(encodeURIComponent(field + _operator + value));
        } else if (value) filters.push(encodeURIComponent(field + (_this2.settings.filters[field].operator ? _this2.settings.filters[field].operator : '=') + value));
        if (_this2.settings.filters[field].value_from) filters.push(encodeURIComponent(field + '>=' + (0, _moment2.default)(_this2.settings.filters[field].value_from, 'YYYY-MM-DD').format('YYYY-MM-DD 00:00:00')));
        if (_this2.settings.filters[field].value_to) filters.push(encodeURIComponent(field + '<=' + (0, _moment2.default)(_this2.settings.filters[field].value_to, 'YYYY-MM-DD').format('YYYY-MM-DD 23:59:59')));
      };

      for (var _iterator8 = Object.keys(this.settings.filters), _isArray8 = Array.isArray(_iterator8), _i8 = 0, _iterator8 = _isArray8 ? _iterator8 : _iterator8[Symbol.iterator]();;) {
        var _ref8;

        var _ret4 = _loop4();

        if (_ret4 === 'break') break;
      }
      if (filters.length) {
        this.hasFilters = true;
        query += (this.prefilter ? '%26' : '&filters=') + filters.join('%26');
      } else this.hasFilters = false;

      var count_query = this.endpoint + query + '&fields=id&depth=0&meta=0';

      if (this.settings.sort_stack.length) {
        var sorts = [];
        for (var _iterator9 = this.settings.sort_stack, _isArray9 = Array.isArray(_iterator9), _i9 = 0, _iterator9 = _isArray9 ? _iterator9 : _iterator9[Symbol.iterator]();;) {
          var _ref9;

          if (_isArray9) {
            if (_i9 >= _iterator9.length) break;
            _ref9 = _iterator9[_i9++];
          } else {
            _i9 = _iterator9.next();
            if (_i9.done) break;
            _ref9 = _i9.value;
          }

          var _field3 = _ref9;

          if (this.settings.sort[_field3] && this.settings.sort[_field3].order) sorts.push(encodeURIComponent((this.settings.sort[_field3].order == 'asc' ? '+' : '-') + _field3));
        }query += '&sort=' + sorts.join(',');
      }

      this.reference_query = this.endpoint + query;

      if (this.settings.limit) {
        query += '&limit=' + this.settings.limit;
      }
      if (this.settings.offset) {
        query += '&offset=' + this.settings.offset;
      }

      this.export_query = this.endpoint + query;

      query = this.parse_query(query);

      this.client.get(this.endpoint + query).then(function (x) {
        _this2.records = _this2.parse_response(x);
        _this2.isLoading = false;
        _this2.records_loaded();
        if (window['ka-table-resize-handler-' + _this2.id]) setTimeout(function () {
          window['ka-table-resize-handler-' + _this2.id]();
        }, 0);
        new Promise(function (resolve) {
          if (x.headers && x.headers.headers && x.headers.headers['x-total-count']) return resolve(x.headers.headers['x-total-count'].value);
          _this2.client.get(count_query).then(function (x2) {
            resolve(_this2.parse_response(x2).length);
          });
        }).then(function (total) {
          _this2.total = total;
          _this2.position = (_this2.records.length > 0 ? parseInt(_this2.settings.offset) + 1 : 0) + '-' + (parseInt(_this2.settings.offset) + parseInt(_this2.settings.limit) > _this2.total ? _this2.total : _this2.records.length == parseInt(_this2.settings.limit) ? parseInt(_this2.settings.offset) + parseInt(_this2.settings.limit) : parseInt(_this2.settings.offset) + _this2.records.length);
          for (var i = 1; i <= Math.ceil(_this2.total / parseInt(_this2.settings.limit)); i++) {
            if (i <= 1) _this2.config_options.pages.datasource = [{ text: String(i), value: String(i) }];else _this2.config_options.pages.datasource.push({ text: String(i), value: String(i) });
          }
        });
      }).catch(function (error) {
        console.error(error);
        _this2.isLoading = false;
        _this2.records = null;
        _this2.error = 'Errore nel caricamento dei dati';
      });

      localStorage.setItem(this.id, JSON.stringify(this.settings));
    };

    KaTable.prototype.format = function format(record, field) {
      var value = null;
      var column = this.dataset.find(function (x) {
        return x.field === field;
      });

      if (!column && !['date_created', 'date_modified'].includes(field)) return record[field];

      if (field.indexOf('.') > 0) {
        var parts = field.split('.');
        value = record[parts[0]] && record[parts[0]][parts[1]] ? record[parts[0]][parts[1]] : null;
      } else {
        value = record[field];
      }

      if (!value) return null;

      if (field === 'date_created' || field === 'date_modified') {
        return _moment2.default.utc(value, 'YYYY-MM-DD').local().format('DD/MM/YYYY');
      } else if (column.control === 'list' && column.datasource) {
        if (typeof column.datasource === 'string' && (column.datasource.indexOf('{') === 0 || column.datasource.indexOf('[') === 0)) {
          column.datasource = JSON.parse(column.datasource);
        }
        var view = column.datasource.model.view || null;
        var keys = !view ? null : view.match(/\{[a-zA-Z0-9_\.]*?\}/g);
        var values = JSON.parse(value);
        var join = column.datasource.model.join || ', ';
        if (view && keys) {
          values.forEach(function (v, i) {
            var nw = view;
            for (var _iterator10 = keys, _isArray10 = Array.isArray(_iterator10), _i10 = 0, _iterator10 = _isArray10 ? _iterator10 : _iterator10[Symbol.iterator]();;) {
              var _ref10;

              if (_isArray10) {
                if (_i10 >= _iterator10.length) break;
                _ref10 = _iterator10[_i10++];
              } else {
                _i10 = _iterator10.next();
                if (_i10.done) break;
                _ref10 = _i10.value;
              }

              var key = _ref10;
              nw = nw.replace(key, v[key.replace(/\{|\}/g, '')] || '');
            }values[i] = nw;
          });
        } else {
          values.forEach(function (v, i) {
            values[i] = Object.values(v).join(' ');
          });
        }
        return values.join(join);
      } else if (column.datamultiple && column.datasource) {
        var _values = [];
        for (var _iterator11 = value, _isArray11 = Array.isArray(_iterator11), _i11 = 0, _iterator11 = _isArray11 ? _iterator11 : _iterator11[Symbol.iterator]();;) {
          var _ref11;

          if (_isArray11) {
            if (_i11 >= _iterator11.length) break;
            _ref11 = _iterator11[_i11++];
          } else {
            _i11 = _iterator11.next();
            if (_i11.done) break;
            _ref11 = _i11.value;
          }

          var v = _ref11;

          var _keys = column.datatext.match(/\{[a-zA-Z0-9_\.]*?\}/g);
          if (_keys) {
            var datatext = column.datatext;
            for (var _iterator12 = _keys, _isArray12 = Array.isArray(_iterator12), _i12 = 0, _iterator12 = _isArray12 ? _iterator12 : _iterator12[Symbol.iterator]();;) {
              var _ref12;

              if (_isArray12) {
                if (_i12 >= _iterator12.length) break;
                _ref12 = _iterator12[_i12++];
              } else {
                _i12 = _iterator12.next();
                if (_i12.done) break;
                _ref12 = _i12.value;
              }

              var key = _ref12;

              datatext = datatext.replace(key, v[key.replace(/\{|\}/g, '')] || '');
            }
            _values.push(datatext);
          } else _values.push(v[column.datatext || 'text']);
        }
        return _values.join(', ');
      } else if (!column.datamultiple && column.datasource && column.control !== 'file') {
        var _keys2 = column.datatext.match(/\{[a-zA-Z0-9_\.]*?\}/g);
        if (typeof column.datasource === 'string' && (column.datasource.indexOf('{') === 0 || column.datasource.indexOf('[') === 0)) {
          column.datasource = JSON.parse(column.datasource);
        }
        if (_keys2) {
          var _datatext = column.datatext;
          for (var _iterator13 = _keys2, _isArray13 = Array.isArray(_iterator13), _i13 = 0, _iterator13 = _isArray13 ? _iterator13 : _iterator13[Symbol.iterator]();;) {
            var _ref13;

            if (_isArray13) {
              if (_i13 >= _iterator13.length) break;
              _ref13 = _iterator13[_i13++];
            } else {
              _i13 = _iterator13.next();
              if (_i13.done) break;
              _ref13 = _i13.value;
            }

            var _key = _ref13;

            _datatext = _datatext.replace(_key, value[_key.replace(/\{|\}/g, '')] || '');
          }
          return _datatext;
        } else if (typeof value === 'string' && Array.isArray(column.datasource)) {
          var _v = column.datasource.filter(function (x) {
            return String(x[column.datavalue]) === String(value);
          });
          if (_v && _v.length) return _v[0][column.datatext];
          return value;
        }
        return value[column.datatext || 'text'];
      } else if (column.datatype === 'json') {
        return JSON.stringify(value);
      } else if (column.control === 'age') {
        return (0, _moment2.default)().diff((0, _moment2.default)(value, 'YYYY-MM-DD'), 'years');
      } else if (column.datatype === 'date') {
        return (column.utc ? _moment2.default.utc(value, 'YYYY-MM-DD').local() : (0, _moment2.default)(value, 'YYYY-MM-DD')).format('DD/MM/YYYY');
      } else if (column.datatype === 'datetime') {
        return (column.utc ? _moment2.default.utc(value, 'YYYY-MM-DD HH:mm:ss').local() : (0, _moment2.default)(value, 'YYYY-MM-DD HH:mm:ss')).format('DD/MM/YYYY HH:mm:ss');
      }
      return value;
    };

    KaTable.prototype.set_sort = function set_sort(field) {
      var sort = this.settings.sort_stack.indexOf(field) > -1 ? this.settings.sort[field] || null : null;
      if (sort) {
        sort.order = sort.order === 'asc' ? 'desc' : sort.order === 'desc' ? null : 'asc';
        if (!sort.order) {
          this.settings.sort[field] = {};
          this.settings.sort_stack.splice(this.settings.sort_stack.indexOf(field), 1);
        }
      } else {
        this.settings.sort_stack.push(field);
        this.settings.sort[field] = { order: 'asc' };
      }
      for (var _iterator14 = this.settings.sort_stack, _isArray14 = Array.isArray(_iterator14), _i14 = 0, _iterator14 = _isArray14 ? _iterator14 : _iterator14[Symbol.iterator]();;) {
        var _ref14;

        if (_isArray14) {
          if (_i14 >= _iterator14.length) break;
          _ref14 = _iterator14[_i14++];
        } else {
          _i14 = _iterator14.next();
          if (_i14.done) break;
          _ref14 = _i14.value;
        }

        var f = _ref14;

        this.settings.sort[f].class = 'sort-' + this.settings.sort[f].order + ' sort-' + (this.settings.sort_stack.indexOf(f) + 1);
      }
      this.load();
    };

    KaTable.prototype.set_page = function set_page(page) {
      var pages = Math.ceil(this.total / parseInt(this.settings.limit));
      if (page == 'first') this.settings.offset = 0;else if (page == 'prev') this.settings.offset = this.settings.offset - parseInt(this.settings.limit) > 0 ? this.settings.offset - parseInt(this.settings.limit) : 0;else if (page == 'next') this.settings.offset = !this.records.length ? this.settings.offset : this.settings.offset + parseInt(this.settings.limit) < this.total ? this.settings.offset + parseInt(this.settings.limit) : parseInt(this.settings.limit) * (pages - 1);else if (page == 'last') this.settings.offset = !this.records.length ? this.settings.offset : parseInt(this.settings.limit) * (pages - 1);else if (typeof page == 'number' || /^[0-9]*?$/g.test(page)) this.settings.offset = parseInt(this.settings.limit) * (parseInt(page) - 1);else return;
      this.load();
    };

    KaTable.prototype.set_limit = function set_limit(limit) {
      this.settings.limit = limit;
      this.load();
    };

    KaTable.prototype.show_options = function show_options($event) {
      var _this3 = this;

      if (this.optionsOpen) return this.hide_options();

      var backdrop = document.createElement('div');
      backdrop.classList.add('ka-table-backdrop');
      backdrop.setAttribute('id', 'ka-table-backdrop-' + this.id);
      backdrop.addEventListener('click', function (event) {
        if (event.target == backdrop) _this3.hide_options();
      });
      document.getElementsByTagName('body')[0].insertBefore(backdrop, document.getElementsByTagName('body')[0].children[0]);

      var drawer = document.querySelectorAll('#' + this.id + ' .ka-table-options')[0];
      if ($event && $event.target) {
        var bounds = $event.target.getBoundingClientRect();
        drawer.style.top = bounds.top + 'px';
        drawer.style.left = bounds.left + bounds.width / 2 + 'px';
      }
      backdrop.appendChild(drawer);
      drawer.classList.remove('hidden');
      setTimeout(function () {
        drawer.classList.add('open');
        _this3.optionsOpen = true;
      }, 100);
    };

    KaTable.prototype.hide_options = function hide_options() {
      var _this4 = this;

      if (!this.optionsOpen) return;

      var drawer = document.querySelectorAll('#ka-table-backdrop-' + this.id + ' .ka-table-options')[0];
      drawer.classList.remove('open');
      setTimeout(function () {
        drawer.classList.add('hidden');
        _this4.element.appendChild(drawer);

        document.getElementsByTagName('body')[0].removeChild(document.getElementById('ka-table-backdrop-' + _this4.id));

        _this4.optionsOpen = false;
      }, 500);
    };

    KaTable.prototype.show_filters = function show_filters() {
      var _this5 = this;

      if (this.filtersOpen) return this.hide_filters();

      var backdrop = document.createElement('div');
      backdrop.classList.add('ka-table-backdrop');
      backdrop.setAttribute('id', 'ka-table-backdrop-' + this.id);
      backdrop.addEventListener('click', function (event) {
        if (event.target == backdrop) _this5.hide_filters();
      });
      document.getElementsByTagName('body')[0].insertBefore(backdrop, document.getElementsByTagName('body')[0].children[0]);

      var drawer = document.querySelectorAll('#' + this.id + ' .ka-table-drawer.filters')[0];
      backdrop.appendChild(drawer);
      drawer.classList.remove('hidden');
      setTimeout(function () {
        drawer.classList.add('open');
        _this5.filtersOpen = true;
      }, 100);
    };

    KaTable.prototype.hide_filters = function hide_filters() {
      var _this6 = this;

      var drawer = document.querySelectorAll('#ka-table-backdrop-' + this.id + ' .ka-table-drawer.filters')[0];
      if (!drawer) return;
      drawer.classList.remove('open');
      setTimeout(function () {
        drawer.classList.add('hidden');
        _this6.element.appendChild(drawer);

        document.getElementsByTagName('body')[0].removeChild(document.getElementById('ka-table-backdrop-' + _this6.id));

        _this6.filtersOpen = false;
      }, 500);
    };

    KaTable.prototype.apply_filters = function apply_filters() {
      this.hide_filters();
      this.settings.offset = 0;
      this.load();
    };

    KaTable.prototype.reset_filters = function reset_filters() {
      if (this.filtersOpen) this.hide_filters();
      this.settings.offset = 0;
      for (var _iterator15 = this.filters, _isArray15 = Array.isArray(_iterator15), _i15 = 0, _iterator15 = _isArray15 ? _iterator15 : _iterator15[Symbol.iterator]();;) {
        var _ref15;

        if (_isArray15) {
          if (_i15 >= _iterator15.length) break;
          _ref15 = _iterator15[_i15++];
        } else {
          _i15 = _iterator15.next();
          if (_i15.done) break;
          _ref15 = _i15.value;
        }

        var _field5 = _ref15;

        if (this.settings.filters[_field5.field]) {
          var default_operator = null;
          if (_field5.datamultiple) default_operator = '~~';else if (_field5.control === 'number') default_operator = '=';else if (_field5.control === 'age') default_operator = '=';
          this.settings.filters[_field5.field] = { operator: default_operator, value: null, value_from: null, value_to: null, control: _field5.control };
        }
        if (_field5.control === 'age') {
          _field5.control = 'number';
          _field5.datatype = 'tinyint(3)';
        }
      }
      this.load();
    };

    KaTable.prototype.show_export = function show_export() {
      var _this7 = this;

      if (this.exportOpen) return this.hide_export();

      var backdrop = document.createElement('div');
      backdrop.classList.add('ka-table-backdrop');
      backdrop.setAttribute('id', 'ka-table-backdrop-' + this.id);
      backdrop.addEventListener('click', function (event) {
        if (event.target == backdrop) _this7.hide_export();
      });
      document.getElementsByTagName('body')[0].insertBefore(backdrop, document.getElementsByTagName('body')[0].children[0]);

      var drawer = document.querySelectorAll('#' + this.id + ' .ka-table-drawer.export')[0];
      backdrop.appendChild(drawer);
      drawer.classList.remove('hidden');
      setTimeout(function () {
        drawer.classList.add('open');
        _this7.exportOpen = true;
      }, 100);
    };

    KaTable.prototype.hide_export = function hide_export() {
      var _this8 = this;

      var drawer = document.querySelectorAll('#ka-table-backdrop-' + this.id + ' .ka-table-drawer.export')[0];
      drawer.classList.remove('open');
      setTimeout(function () {
        drawer.classList.add('hidden');
        _this8.element.appendChild(drawer);

        document.getElementsByTagName('body')[0].removeChild(document.getElementById('ka-table-backdrop-' + _this8.id));

        _this8.exportOpen = false;
      }, 500);
    };

    KaTable.prototype.select_export = function select_export() {
      for (var _iterator16 = this.export_schema, _isArray16 = Array.isArray(_iterator16), _i16 = 0, _iterator16 = _isArray16 ? _iterator16 : _iterator16[Symbol.iterator]();;) {
        var _ref16;

        if (_isArray16) {
          if (_i16 >= _iterator16.length) break;
          _ref16 = _iterator16[_i16++];
        } else {
          _i16 = _iterator16.next();
          if (_i16.done) break;
          _ref16 = _i16.value;
        }

        var _field6 = _ref16;

        this.settings.exports[_field6.field] = true;
      }
    };

    KaTable.prototype.unselect_export = function unselect_export() {
      for (var _iterator17 = this.export_schema, _isArray17 = Array.isArray(_iterator17), _i17 = 0, _iterator17 = _isArray17 ? _iterator17 : _iterator17[Symbol.iterator]();;) {
        var _ref17;

        if (_isArray17) {
          if (_i17 >= _iterator17.length) break;
          _ref17 = _iterator17[_i17++];
        } else {
          _i17 = _iterator17.next();
          if (_i17.done) break;
          _ref17 = _i17.value;
        }

        var _field7 = _ref17;

        this.settings.exports[_field7.field] = false;
      }
    };

    KaTable.prototype.apply_export = function apply_export($event) {
      var _this9 = this;

      var exportPages = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      if ($event && $event.model) $event.model.busy = true;
      var fields = Object.keys(this.settings.exports).reduce(function (acc, k) {
        if (_this9.settings.exports[k] === true) acc.push(k);return acc;
      }, []).join(',');
      var query = this.export_query;
      if (exportPages === 'ALL') {
        query = query.replace(/&limit=\d*/, '');
        query = query.replace(/&offset=\d*/, '');
      }
      this.client.get(query + '&depth=1&meta=0&fields=' + fields).then(function (x) {
        var records = _this9.parse_response(x);
        if (!records.length) {
          _this9.toast.show('<strong>Nessun risulta alcun dato da esportare!</strong>', 'error');
          return;
        }
        var csv = [Object.keys(records[0]).join(';')];
        for (var _iterator18 = records, _isArray18 = Array.isArray(_iterator18), _i18 = 0, _iterator18 = _isArray18 ? _iterator18 : _iterator18[Symbol.iterator]();;) {
          var _ref18;

          if (_isArray18) {
            if (_i18 >= _iterator18.length) break;
            _ref18 = _iterator18[_i18++];
          } else {
            _i18 = _iterator18.next();
            if (_i18.done) break;
            _ref18 = _i18.value;
          }

          var record = _ref18;

          var values = [];

          var _loop5 = function _loop5() {
            if (_isArray19) {
              if (_i19 >= _iterator19.length) return 'break';
              _ref19 = _iterator19[_i19++];
            } else {
              _i19 = _iterator19.next();
              if (_i19.done) return 'break';
              _ref19 = _i19.value;
            }

            var k = _ref19;

            var value = _this9.dataset.find(function (f) {
              return f.field === k;
            }) ? _this9.format(record, k) : record[k];
            if (typeof value === 'string') {
              value = value.replace('"', '""');
              value = '"' + value + '"';
            }
            values.push(value);
          };

          for (var _iterator19 = Object.keys(record), _isArray19 = Array.isArray(_iterator19), _i19 = 0, _iterator19 = _isArray19 ? _iterator19 : _iterator19[Symbol.iterator]();;) {
            var _ref19;

            var _ret5 = _loop5();

            if (_ret5 === 'break') break;
          }
          csv.push(values.join(';'));
        }
        csv = csv.join('\n');
        var blob = new Blob([csv], { type: 'text/csv' });
        var anchor = document.createElement('a');
        anchor.download = (0, _moment2.default)().format('YYYY-MM-DD_HH-mm') + '_' + _this9.endpoint.replace(/[^a-zA-Z0-9]/g, '-') + '.csv';
        anchor.href = window.URL.createObjectURL(blob);
        document.body.appendChild(anchor);
        anchor.click();
        document.body.removeChild(anchor);
        _this9.hide_export();
      }).finally(function () {
        if ($event && $event.model) $event.model.busy = false;
      });
    };

    KaTable.prototype.add = function add() {
      var _this10 = this;

      if (this.routes.edit === false) return;
      if (this.routes.dialog) {
        var childRoute = this.router.routes.filter(function (x) {
          return x.name == (_this10.routes.add || _this10.router.currentInstruction.config.name);
        })[0];
        this.dialog.open({
          title: childRoute.title,
          viewModel: childRoute.moduleId,
          viewModelParams: { id: 'new', data: this.routes.data || {} }
        }, true).whenClosed(function (response) {
          if (!response.wasCancelled) {
            _this10.load();
          }
        });
      } else this.router.navigateToRoute(this.routes.add || this.router.currentInstruction.config.name, { id: 'new' });
    };

    KaTable.prototype.edit = function edit(record) {
      var _this11 = this;

      var listRefQuery = this.reference_query + '&fields=id&limit=1&offset=' + (parseInt(this.settings.offset || 0, 10) + this.records.indexOf(record));
      if (this.actions.indexOf('edit') < 0) return;
      if (this.routes.edit === false) return;
      if (this.routes.dialog) {
        var childRoute = this.router.routes.filter(function (x) {
          return x.name == (_this11.routes.edit || _this11.router.currentInstruction.config.name);
        })[0];
        this.dialog.open({
          title: childRoute.title,
          viewModel: childRoute.moduleId,
          viewModelParams: { id: record.id || record.uuid, listRefQuery: btoa(listRefQuery) }
        }, true).whenClosed(function (response) {
          if (!response.wasCancelled) {
            _this11.load();
          }
        });
      } else this.router.navigateToRoute(this.routes.edit || this.router.currentInstruction.config.name, { id: record.id || record.uuid, listRefQuery: btoa(listRefQuery) });
    };

    KaTable.prototype.copy = function copy(record) {
      var _this12 = this;

      var deep = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      if (this.routes.edit === false) return;
      if (deep) {
        var fields = this.dataset.filter(function (x) {
          return x.unique;
        });
        var duplicate = function duplicate(data) {
          var d = _this12.params && _this12.params.deepcopy ? JSON.parse(JSON.stringify(_this12.params.deepcopy)) : { depth: 1 };
          d.data = data;
          _this12.client.post('duplicate/' + (record.id || record.uuid), d).then(function (x) {
            _this12.toast.show('<strong>Record duplicato</strong>', 'success');
            _this12.load();
          }).catch(function (x) {
            var error = JSON.parse(x.response).errors[0].msg;
            _this12.toast.show('<strong>' + error + '</strong>', 'error');
          });
        };
        if (fields.length) {
          var template = '',
              config = {},
              model = {};
          for (var _iterator20 = fields, _isArray20 = Array.isArray(_iterator20), _i20 = 0, _iterator20 = _isArray20 ? _iterator20 : _iterator20[Symbol.iterator]();;) {
            var _ref20;

            if (_isArray20) {
              if (_i20 >= _iterator20.length) break;
              _ref20 = _iterator20[_i20++];
            } else {
              _i20 = _iterator20.next();
              if (_i20.done) break;
              _ref20 = _i20.value;
            }

            var _field8 = _ref20;

            config[_field8.field] = _field8;
            model[_field8.field] = null;
            template += '<ka-input config.bind="params.viewStrategyParams.config.' + _field8.field + '" value.bind="params.viewStrategyParams.model.' + _field8.field + '"></ka-input>';
          }
          var viewStrategy = new _aureliaFramework.InlineViewStrategy('<template>' + template + '</template>');
          var viewStrategyParams = { config: config, model: model };
          this.dialog.open({
            type: 'confirm',
            title: 'Duplica record',
            viewStrategy: viewStrategy,
            viewStrategyParams: viewStrategyParams
          }, true).whenClosed(function (response) {
            console.log(viewStrategyParams.model);
            if (!response.wasCancelled) {
              duplicate(viewStrategyParams.model);
            }
          });
        } else duplicate();
      } else {
        this.client.get(this.endpoint + '/' + (record.id || record.uuid), { meta: 0, depth: 0 }).then(function (x) {
          var data = x.response;
          delete data.id;
          delete data.uuid;

          if (_this12.routes.dialog) {
            var childRoute = _this12.router.routes.filter(function (x) {
              return x.name == (_this12.routes.edit || _this12.router.currentInstruction.config.name);
            })[0];
            _this12.dialog.open({
              title: childRoute.title,
              viewModel: childRoute.moduleId,
              viewModelParams: { id: 'new', data: data }
            }, true).whenClosed(function (response) {
              if (!response.wasCancelled) {
                _this12.load();
              }
            });
          } else _this12.router.navigateToRoute(_this12.routes.edit || _this12.router.currentInstruction.config.name, { id: 'new', data: data });
        });
      }
    };

    KaTable.prototype.delete = function _delete(record) {
      var _this13 = this;

      if (this.routes.edit === false) return;
      this.dialog.open({
        type: 'confirm',
        class: 'warning',
        title: 'Elimina',
        body: 'Eliminare definitivamente il record?'
      }, true).whenClosed(function (response) {
        if (!response.wasCancelled) {
          _this13.client.delete(_this13.endpoint + '/' + (record.id || record.uuid)).then(function (x) {
            _this13.toast.show('<strong>Record eliminato</strong>', 'success');
            _this13.load();
          }).catch(function (x) {
            var error = JSON.parse(x.response).errors[0].msg;
            _this13.toast.show('<strong>' + error + '</strong>', 'error');
          });
        }
      });
    };

    KaTable.prototype.parse_response = function parse_response(msg) {
      if (msg.responseType === 'json' && typeof msg.response === 'string') msg.response = JSON.parse(msg.response);
      return msg.response;
    };

    return KaTable;
  }(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'records', [_dec3], {
    enumerable: true,
    initializer: function initializer() {
      return null;
    }
  }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'schema', [_dec4], {
    enumerable: true,
    initializer: function initializer() {
      return null;
    }
  }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'export_schema', [_dec5], {
    enumerable: true,
    initializer: function initializer() {
      return null;
    }
  }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, 'columns_schema', [_dec6], {
    enumerable: true,
    initializer: function initializer() {
      return null;
    }
  }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, 'filters', [_dec7], {
    enumerable: true,
    initializer: function initializer() {
      return null;
    }
  }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, 'endpoint', [_dec8], {
    enumerable: true,
    initializer: function initializer() {
      return null;
    }
  }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, 'limit', [_dec9], {
    enumerable: true,
    initializer: function initializer() {
      return null;
    }
  }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, 'depth', [_dec10], {
    enumerable: true,
    initializer: function initializer() {
      return null;
    }
  }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, 'client', [_dec11], {
    enumerable: true,
    initializer: function initializer() {
      return null;
    }
  }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, 'columns', [_dec12], {
    enumerable: true,
    initializer: function initializer() {
      return null;
    }
  }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, 'filtrables', [_dec13], {
    enumerable: true,
    initializer: function initializer() {
      return null;
    }
  }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, 'sortables', [_dec14], {
    enumerable: true,
    initializer: function initializer() {
      return null;
    }
  }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, 'editables', [_dec15], {
    enumerable: true,
    initializer: function initializer() {
      return null;
    }
  }), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, 'exportables', [_dec16], {
    enumerable: true,
    initializer: function initializer() {
      return null;
    }
  }), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, 'prefilter', [_dec17], {
    enumerable: true,
    initializer: function initializer() {
      return null;
    }
  }), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, 'routes', [_dec18], {
    enumerable: true,
    initializer: function initializer() {
      return { add: null, edit: null, dialog: false, data: {} };
    }
  }), _descriptor17 = _applyDecoratedDescriptor(_class2.prototype, 'actions', [_dec19], {
    enumerable: true,
    initializer: function initializer() {
      return ["filter", "export", "add", "edit"];
    }
  }), _descriptor18 = _applyDecoratedDescriptor(_class2.prototype, 'params', [_dec20], {
    enumerable: true,
    initializer: function initializer() {
      return {};
    }
  }), _descriptor19 = _applyDecoratedDescriptor(_class2.prototype, 'query', [_dec21], {
    enumerable: true,
    initializer: function initializer() {
      return '';
    }
  })), _class2)) || _class) || _class);
});