'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.KaEnterCustomAttribute = undefined;

var _dec, _dec2, _class;

var _aureliaFramework = require('aurelia-framework');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var KaEnterCustomAttribute = exports.KaEnterCustomAttribute = (_dec = (0, _aureliaFramework.customAttribute)('ka-enter'), _dec2 = (0, _aureliaFramework.inject)(Element), _dec(_class = _dec2(_class = function () {
  function KaEnterCustomAttribute(element) {
    var _this = this;

    _classCallCheck(this, KaEnterCustomAttribute);

    this._callback = null;

    this.element = element;

    this.element.addEventListener('keydown', function (e) {
      var inputs = [];
      if (_this.element.tagName === 'INPUT') inputs = [_this.element];else inputs = Array.from(_this.element.querySelectorAll('input'));
      if (e.keyCode === 13 && inputs.includes(e.target)) {
        if (typeof _this._callback === 'function') {
          e.target.blur();
          _this._callback({ event: e });
        }
      }
    });
  }

  KaEnterCustomAttribute.prototype.bind = function bind() {
    this._callback = this.value;
  };

  return KaEnterCustomAttribute;
}()) || _class) || _class);