import { PLATFORM } from 'aurelia-framework';
import { KaConsole } from './ka-console/ka-console';

export * from './ka-dialog/ka-dialog';
export * from './ka-toast/ka-toast';
export * from './ka-api/ka-api';

window.konsole = new KaConsole();

export function configure(config) {
  config.globalResources([PLATFORM.moduleName('./ka-button/ka-button')]);
  config.globalResources([PLATFORM.moduleName('./ka-input/ka-input')]);
  config.globalResources([PLATFORM.moduleName('./ka-input/ka-input-controls')]);
  config.globalResources([PLATFORM.moduleName('./ka-navbar/ka-navbar')]);
  config.globalResources([PLATFORM.moduleName('./ka-resource/ka-resource')]);
  config.globalResources([PLATFORM.moduleName('./ka-table/ka-table')]);
  config.globalResources([PLATFORM.moduleName('./ka-table/ka-tableFilters')]);
  config.globalResources([PLATFORM.moduleName('./ka-tabs/ka-tabs')]);
  config.globalResources([PLATFORM.moduleName('./ka-tooltip/ka-tooltip')]);
  config.globalResources([PLATFORM.moduleName('./ka-enter/ka-enter')]);

  config.globalResources([PLATFORM.moduleName('./ka-progress/ka-progress')]);
  config.globalResources([PLATFORM.moduleName('./ka-layout/ka-layout')]);

  config.globalResources([PLATFORM.moduleName('./ka-control/ka-control')]);
  config.globalResources([PLATFORM.moduleName('./ka-control-check/ka-control-check')]);
  config.globalResources([PLATFORM.moduleName('./ka-control-combo/ka-control-combo')]);
  config.globalResources([PLATFORM.moduleName('./ka-control-date/ka-control-date')]);
  config.globalResources([PLATFORM.moduleName('./ka-control-editor/ka-control-editor')]);
  config.globalResources([PLATFORM.moduleName('./ka-control-file/ka-control-file')]);
  config.globalResources([PLATFORM.moduleName('./ka-control-list/ka-control-list')]);
  config.globalResources([PLATFORM.moduleName('./ka-control-number/ka-control-number')]);
  config.globalResources([PLATFORM.moduleName('./ka-control-password/ka-control-password')]);
  config.globalResources([PLATFORM.moduleName('./ka-control-table/ka-control-table')]);
  config.globalResources([PLATFORM.moduleName('./ka-control-text/ka-control-text')]);
  config.globalResources([PLATFORM.moduleName('./ka-control-textarea/ka-control-textarea')]);
}