var _dec, _dec2, _dec3, _dec4, _class, _desc, _value, _class2, _descriptor, _descriptor2;

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import { inject, customElement, bindable } from 'aurelia-framework';

export let KaButton = (_dec = customElement('ka-button'), _dec2 = inject(Element), _dec3 = bindable(), _dec4 = bindable(), _dec(_class = _dec2(_class = (_class2 = class KaButton {

  constructor(element) {
    _initDefineProp(this, 'disabled', _descriptor, this);

    _initDefineProp(this, 'busy', _descriptor2, this);

    this._ready = false;

    this.element = element;
  }

  bind(bindingContext) {
    this.parent = bindingContext;

    this.disabled = this.disabled === '' ? true : this.disabled;
    this.disabled = this.disabled === null || typeof this.disabled === 'undefined' ? false : this.disabled;
    this.disabled = this.disabled === 'false' ? false : Boolean(this.disabled);
  }

  attached() {
    this._ready = true;
    this.element.addEventListener('click', e => {
      if (this.disabled || this.busy) e.stopPropagation();else e.model = this;
    });

    let active = e => {
      if (!this.disabled && !this.busy) this.element.classList.toggle('active');
    };
    this.element.addEventListener('mousedown', active);
    this.element.addEventListener('touchstart', active);
    this.element.addEventListener('mouseup', active);
    this.element.addEventListener('touchend', active);

    this.init();
  }

  disabledChanged(value) {
    value = value === 'false' ? false : Boolean(value);
    this.disabled = value;
    if (this._ready) this.init();
  }
  busyChanged(value) {
    if (this._ready) this.init();
  }

  init() {
    if (this.disabled === true) this.element.classList.add('disabled');else this.element.classList.remove('disabled');
    if (this.busy) this.element.classList.add('busy');else this.element.classList.remove('busy');
  }

}, (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'disabled', [_dec3], {
  enumerable: true,
  initializer: null
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'busy', [_dec4], {
  enumerable: true,
  initializer: function () {
    return false;
  }
})), _class2)) || _class) || _class);