var _dec, _dec2, _class;

import { inject, customAttribute } from 'aurelia-framework';

export let KaEnterCustomAttribute = (_dec = customAttribute('ka-enter'), _dec2 = inject(Element), _dec(_class = _dec2(_class = class KaEnterCustomAttribute {

  constructor(element) {
    this._callback = null;

    this.element = element;

    this.element.addEventListener('keydown', e => {
      let inputs = [];
      if (this.element.tagName === 'INPUT') inputs = [this.element];else inputs = Array.from(this.element.querySelectorAll('input'));
      if (e.keyCode === 13 && inputs.includes(e.target)) {
        if (typeof this._callback === 'function') {
          e.target.blur();
          this._callback({ event: e });
        }
      }
    });
  }

  bind() {
    this._callback = this.value;
  }
}) || _class) || _class);