var _dec, _dec2, _dec3, _class, _desc, _value, _class2, _descriptor;

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import { inject, customElement, observable } from 'aurelia-framework';
import { Router } from 'aurelia-router';
import { KaApi } from '../ka-api/ka-api';
import environment from 'environment';

export let KaNavbar = (_dec = customElement('ka-navbar'), _dec2 = inject(Element, Router, KaApi), _dec3 = observable(), _dec(_class = _dec2(_class = (_class2 = class KaNavbar {

  constructor(element, router, api) {
    _initDefineProp(this, 'visible', _descriptor, this);

    this.appName = environment.appName;

    this.element = element;
    this.router = router;
    this.api = api;
    document.addEventListener('click', e => {
      if (!this.visible) return;
      let target = e.target;
      while (target) {
        if (target === this.nav) return;
        if (target === this.button) return;
        target = target.parentNode;
      }
      this.hide();
    });
  }

  attached() {
    this.routes = [];
    for (let route of this.router.navigation) {
      if (!this.api.user && !route.settings.authGroups) this.routes.push(route);else if (this.api.user && !route.settings.authGroups) this.routes.push(route);else if (this.api.user && route.settings.authGroups && this.api.user.groups && this.api.user.groups.some(e => route.settings.authGroups.includes(e))) this.routes.push(route);
    }
  }

  hide() {
    this.visible = false;
  }

  show() {
    this.visible = true;
  }

  toggle() {
    this.visible = !this.visible;
  }

}, (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'visible', [_dec3], {
  enumerable: true,
  initializer: function () {
    return false;
  }
})), _class2)) || _class) || _class);