var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _dec14, _dec15, _dec16, _dec17, _dec18, _dec19, _dec20, _dec21, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16, _descriptor17, _descriptor18, _descriptor19;

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import { inject, customElement, bindable, bindingMode, InlineViewStrategy } from 'aurelia-framework';
import { Router } from 'aurelia-router';
import { KaDialog } from '../ka-dialog/ka-dialog';
import { KaToast } from '../ka-toast/ka-toast';
import moment from 'moment';

export let KaTable = (_dec = customElement('ka-table'), _dec2 = inject(Element, Router, KaDialog, KaToast), _dec3 = bindable(), _dec4 = bindable(), _dec5 = bindable(), _dec6 = bindable(), _dec7 = bindable(), _dec8 = bindable(), _dec9 = bindable(), _dec10 = bindable(), _dec11 = bindable(), _dec12 = bindable(), _dec13 = bindable(), _dec14 = bindable(), _dec15 = bindable(), _dec16 = bindable(), _dec17 = bindable(), _dec18 = bindable(), _dec19 = bindable(), _dec20 = bindable(), _dec21 = bindable(), _dec(_class = _dec2(_class = (_class2 = class KaTable {

  constructor(element, router, dialog, toast) {
    _initDefineProp(this, 'records', _descriptor, this);

    _initDefineProp(this, 'schema', _descriptor2, this);

    _initDefineProp(this, 'export_schema', _descriptor3, this);

    _initDefineProp(this, 'columns_schema', _descriptor4, this);

    _initDefineProp(this, 'filters', _descriptor5, this);

    _initDefineProp(this, 'endpoint', _descriptor6, this);

    _initDefineProp(this, 'limit', _descriptor7, this);

    _initDefineProp(this, 'depth', _descriptor8, this);

    _initDefineProp(this, 'client', _descriptor9, this);

    _initDefineProp(this, 'columns', _descriptor10, this);

    _initDefineProp(this, 'filtrables', _descriptor11, this);

    _initDefineProp(this, 'sortables', _descriptor12, this);

    _initDefineProp(this, 'editables', _descriptor13, this);

    _initDefineProp(this, 'exportables', _descriptor14, this);

    _initDefineProp(this, 'prefilter', _descriptor15, this);

    _initDefineProp(this, 'routes', _descriptor16, this);

    _initDefineProp(this, 'actions', _descriptor17, this);

    _initDefineProp(this, 'params', _descriptor18, this);

    _initDefineProp(this, 'query', _descriptor19, this);

    this.schema_loaded = () => {};

    this.filters_loaded = () => {};

    this.parse_query = query => {
      return query;
    };

    this.records_loaded = () => {};

    this.id = null;
    this.settings = {
      filters: null,
      exports: null,
      sort: {},
      sort_stack: [],
      sort_columns: {},
      offset: 0,
      limit: '10'
    };
    this.config_operators = {
      text: {
        field: 'operator',
        control: 'combo',
        datapreload: true,
        datasource: [{ value: '=', text: 'Uguale a' }, { value: '!=', text: 'Diverso da' }, { value: '^=', text: 'Inizia con' }, { value: '~', text: 'Contiene' }, { value: '!~', text: 'Non contiene' }]
      },
      json: {
        field: 'operator',
        control: 'combo',
        datapreload: true,
        datasource: [{ value: '~', text: 'Contiene' }]
      },
      number: {
        field: 'operator',
        control: 'combo',
        datapreload: true,
        datasource: [{ value: '=', text: 'Uguale a' }, { value: '!=', text: 'Diverso da' }, { value: '>=', text: 'Maggiore uguale a' }, { value: '<=', text: 'Minore uguale a' }]
      }
    };
    this.config_metas = [{ field: 'id', label: 'Id', control: 'number' }, { field: 'date_created', label: 'Data creazione', control: 'date' }, { field: 'user_created', label: 'Creato da', control: 'number' }, { field: 'date_modified', label: 'Data ultima modifica', control: 'date' }, { field: 'user_modified', label: 'Modificato da', control: 'number' }];
    this.config_options = {
      limit: { field: 'option-limit', label: 'Record per pagina', control: 'combo', datapreload: true, datasource: [{ value: '10', text: '10' }, { value: '25', text: '25' }, { value: '50', text: '50' }, { value: '100', text: '100' }, { value: '200', text: '200' }] },
      pages: { field: 'option-pages', label: 'Salta alla pagina', control: 'combo', datapreload: true, datasource: [] }
    };
    this.position = null;
    this.hasFilters = false;
    this.isLoading = true;
    this.schemaLoaded = false;
    this.error = null;

    this.element = element;
    this.router = router;
    this.dialog = dialog;
    this.toast = toast;
  }

  bind(bindingContext, overrideContext) {
    this.parent = bindingContext;
  }

  detached() {
    this.hide_options();
    this.hide_filters();
    window.removeEventListener('resize', window[`ka-table-resize-handler-${this.id}`]);
    delete window[`ka-table-resize-handler-${this.id}`];
  }

  attached() {
    if (!this.endpoint && this.parent.endpoint) this.endpoint = this.parent.endpoint;
    if (!this.client && this.parent.api && this.parent.api.client) this.client = this.parent.api.client;
    if (this.columns && typeof this.columns == 'string') this.columns = this.columns.split(',');
    if (this.filtrables && typeof this.filtrables == 'string') this.filtrables = this.filtrables.split(',');
    if (this.sortables && typeof this.sortables === 'string') this.sortables = this.sortables.split(',');
    if (this.exportables && typeof this.exportables == 'string') this.exportables = this.exportables.split(',');
    if (this.actions && typeof this.actions == 'string') this.actions = this.actions === "" ? [] : this.actions.split(',');
    if (this.limit) this.settings.limit = String(this.limit);

    let userId = this.parent.api && this.parent.api.user && this.parent.api.user.id ? this.parent.api.user.id : null;
    let appVer = this.parent.api && this.parent.api.environment && this.parent.api.environment.version ? this.parent.api.environment.version : null;
    appVer = !appVer && this.parent.environment && this.parent.environment.version ? this.parent.environment.version : appVer;

    this.id = btoa('§' + userId + '-' + appVer + '§' + this.prefilter + '§' + this.endpoint + '§' + location.pathname + '§' + (this.columns ? this.columns.join('') : '')).replace(/[\W_]+/g, '').slice(0, 120);
    this.element.setAttribute('id', this.id);

    if (localStorage.getItem(this.id)) {
      this.settings = JSON.parse(localStorage.getItem(this.id));
    } else if (sessionStorage.getItem(this.id)) {
      this.settings = JSON.parse(sessionStorage.getItem(this.id));
    }
    this.init();

    this.element.querySelector('.ka-wrapper').addEventListener('scroll', event => {
      event.target.querySelectorAll('.floater').forEach(floater => {
        floater.style.transform = `translateX(${event.target.scrollLeft}px)`;
      });
    });

    eval(`window['ka-table-resize-handler-${this.id}'] = function() {
      var element = document.querySelector('#${this.id}');
      if (!element) return;
      if (element.classList.contains('full-height')) {
        element.style.height = parseInt(window.innerHeight - element.getBoundingClientRect().top) + 'px';
      }
      var table = element.querySelector('table');
      table.querySelectorAll('tbody td.ka-tr-tools:last-child').forEach(function (element) {
        var floater = element.querySelector('.floater');
        if (!floater) return;
        var h = element.getBoundingClientRect().height;
        var w = floater.getBoundingClientRect().width;
        if (floater && h && w) {
          floater.classList.add('float');
          floater.style.height = h + 'px';
          element.style.minWidth = w + 'px';
        }
      });
    }`);
    window.addEventListener('resize', window[`ka-table-resize-handler-${this.id}`]);
  }

  init() {
    if (!this.client || !this.endpoint) return console.warn('[mk-table] missing client or endpoint configuration');
    this.isLoading = true;
    this.error = null;
    this.hide_options();

    this.client.get('datasets/' + this.endpoint).then(x => {
      this.dataset = this.parse_response(x);
      let dataset = this.parse_response(x);
      let promises = [];

      if (!this.schema) {
        if (this.columns) {
          let fields = (this.columns || []).concat((this.filtrables || []).filter(item => this.columns.indexOf(item) < 0));
          this.schema = [];
          this.columns_schema = [];
          for (let field of fields) {
            if (field.indexOf('.') > 0) {
              let parts = field.split('.');
              let fieldDataset = dataset.find(o => o.field === parts[0]);
              let datasource = fieldDataset.datasource ? JSON.parse(fieldDataset.datasource) : null;
              if (datasource && datasource.table) {
                let fieldSchema = { field: `${parts[0]}.${parts[1]}` };
                this.schema.push(fieldSchema);
                if (this.columns.includes(fieldSchema.field)) this.columns_schema.push(fieldSchema);
                promises.push(this.client.get('datasets/' + datasource.table).then(x => {
                  let schema = this.parse_response(x).find(o => o.field === parts[1]) || {};
                  schema.field = fieldSchema.field;
                  this.schema[this.schema.findIndex(o => o.field === fieldSchema.field)] = schema;
                  if (this.columns.includes(fieldSchema.field)) this.columns_schema[this.columns_schema.findIndex(o => o.field === fieldSchema.field)] = schema;
                  this.dataset.push(schema);
                }));
              }
            } else {
              let fieldSchema = dataset.find(o => o.field === field) || Object.assign({}, this.config_metas.find(o => o.field === field));
              this.schema.push(fieldSchema);
              if (this.columns.includes(field)) this.columns_schema.push(fieldSchema);
            }
          }
        } else {
          this.columns_schema = this.schema = dataset;
        }
      }
      Promise.all(promises).finally(() => {
        this.schemaLoaded = true;
        this.schema_loaded();

        for (let column of this.schema) {
          let field = column.field;
          if (field) {
            let fieldKebab = field.replace(/([a-z])([A-Z])/g, '$1-$2').replace(/\s+/g, '-').toLowerCase();
            if (this.sortables && this.sortables.includes(field)) {
              this.settings.sort_columns[field] = field;
            } else if (this.sortables && this.sortables.includes(fieldKebab)) {
              this.settings.sort_columns[field] = fieldKebab;
            } else if (!this.sortables) {
              this.settings.sort_columns[field] = field;
            }
          }
        }

        if (this.exportables && !this.export_schema) {
          this.export_schema = [];
          for (let field of this.exportables) {
            let export_field = Object.assign({}, dataset.find(o => o.field === field) || Object.assign({}, this.config_metas.find(o => o.field === field)));
            this.export_schema.push(export_field);
          }
        } else if (!this.export_schema) {
          this.export_schema = [];
          for (let field of dataset) {
            let export_field = Object.assign({}, field);
            this.export_schema.push(export_field);
          }
        }

        if (this.filtrables && !this.filters) {
          this.filters = [];
          for (let field of this.filtrables) {
            let filter = Object.assign({}, dataset.find(o => o.field === field) || Object.assign({}, this.config_metas.find(o => o.field === field)));
            if (filter.control === 'combo') filter.datamultiple = true;
            if (filter.datatype === 'json') filter.control = 'text';
            if (filter.control === 'textarea' || filter.control === 'editor') filter.control = 'text';
            this.filters.push(filter);
          }
        } else if (!this.filters) {
          this.filters = [];
          for (let filter of dataset) {
            filter = Object.assign({}, filter);
            if (filter.control === 'combo') filter.datamultiple = true;
            if (filter.datatype === 'json') filter.control = 'text';
            if (filter.control === 'textarea' || filter.control === 'editor') filter.control = 'text';
            this.filters.push(filter);
          }
        }
        this.filters_loaded();

        this.load();
      });
    }).catch(error => {
      console.error(error);
      this.isLoading = false;
      this.records = null;
      this.error = 'Errore nel caricamento dei dati';
    });
  }

  load() {
    this.isLoading = true;
    this.error = null;
    this.hide_options();

    if (!this.settings.exports) this.settings.exports = {};

    if (!this.settings.filters) this.settings.filters = {};
    for (let field of this.filters) {
      if (!this.settings.filters[field.field]) {
        let default_operator = null;
        if (field.datamultiple) default_operator = '~~';else if (field.control === 'number') default_operator = '=';else if (field.control === 'age') default_operator = '=';
        this.settings.filters[field.field] = { operator: default_operator, value: null, value_from: null, value_to: null, control: field.control };
      }
      if (field.control === 'age') {
        field.control = 'number';
        field.datatype = 'tinyint(3)';
      }
    }

    let query = this.query + (this.query.indexOf('?') >= 0 ? '&' : '?') + 'meta=1';
    if (this.depth) query += '&depth=' + this.depth;
    if (this.prefilter) query += '&filters=' + encodeURIComponent(this.prefilter);
    let filters = [];
    for (let field of Object.keys(this.settings.filters)) {
      let value = this.settings.filters[field].value || null;
      if (value && this.settings.filters[field].control === 'age') {
        value = parseInt(value, 10);
        let operator = this.settings.filters[field].operator || null;
        if (operator === '<=') filters.push(encodeURIComponent(field + '>=' + moment().subtract(parseInt(value, 10) + 1, 'years').format('YYYY-MM-DD')));else if (operator === '>=') filters.push(encodeURIComponent(field + '<' + moment().subtract(value, 'years').format('YYYY-MM-DD')));else filters.push(encodeURIComponent(field + '<' + moment().subtract(value, 'years').format('YYYY-MM-DD') + '&' + field + '>=' + moment().subtract(value + 1, 'years').format('YYYY-MM-DD')));
      } else if (value && this.settings.filters[field].control === 'combo') {
        let operator = this.settings.filters[field].operator || '=';
        let filter = this.filters.find(x => x.field === field);
        if (filter && Array.isArray(filter.datasource)) {
          let item = filter.datasource.find(x => x.value === value);
          if (item && item.filter_operator) operator = item.filter_operator;
          if (item && item.filter_value) value = item.filter_value;
        }
        filters.push(encodeURIComponent(field + operator + value));
      } else if (value) filters.push(encodeURIComponent(field + (this.settings.filters[field].operator ? this.settings.filters[field].operator : '=') + value));
      if (this.settings.filters[field].value_from) filters.push(encodeURIComponent(field + '>=' + moment(this.settings.filters[field].value_from, 'YYYY-MM-DD').format('YYYY-MM-DD 00:00:00')));
      if (this.settings.filters[field].value_to) filters.push(encodeURIComponent(field + '<=' + moment(this.settings.filters[field].value_to, 'YYYY-MM-DD').format('YYYY-MM-DD 23:59:59')));
    }
    if (filters.length) {
      this.hasFilters = true;
      query += (this.prefilter ? '%26' : '&filters=') + filters.join('%26');
    } else this.hasFilters = false;

    let count_query = this.endpoint + query + '&fields=id&depth=0&meta=0';

    if (this.settings.sort_stack.length) {
      let sorts = [];
      for (let field of this.settings.sort_stack) if (this.settings.sort[field] && this.settings.sort[field].order) sorts.push(encodeURIComponent((this.settings.sort[field].order == 'asc' ? '+' : '-') + field));
      query += '&sort=' + sorts.join(',');
    }

    this.reference_query = this.endpoint + query;

    if (this.settings.limit) {
      query += '&limit=' + this.settings.limit;
    }
    if (this.settings.offset) {
      query += '&offset=' + this.settings.offset;
    }

    this.export_query = this.endpoint + query;

    query = this.parse_query(query);

    this.client.get(this.endpoint + query).then(x => {
      this.records = this.parse_response(x);
      this.isLoading = false;
      this.records_loaded();
      if (window[`ka-table-resize-handler-${this.id}`]) setTimeout(() => {
        window[`ka-table-resize-handler-${this.id}`]();
      }, 0);
      new Promise(resolve => {
        if (x.headers && x.headers.headers && x.headers.headers['x-total-count']) return resolve(x.headers.headers['x-total-count'].value);
        this.client.get(count_query).then(x2 => {
          resolve(this.parse_response(x2).length);
        });
      }).then(total => {
        this.total = total;
        this.position = (this.records.length > 0 ? parseInt(this.settings.offset) + 1 : 0) + '-' + (parseInt(this.settings.offset) + parseInt(this.settings.limit) > this.total ? this.total : this.records.length == parseInt(this.settings.limit) ? parseInt(this.settings.offset) + parseInt(this.settings.limit) : parseInt(this.settings.offset) + this.records.length);
        for (let i = 1; i <= Math.ceil(this.total / parseInt(this.settings.limit)); i++) {
          if (i <= 1) this.config_options.pages.datasource = [{ text: String(i), value: String(i) }];else this.config_options.pages.datasource.push({ text: String(i), value: String(i) });
        }
      });
    }).catch(error => {
      console.error(error);
      this.isLoading = false;
      this.records = null;
      this.error = 'Errore nel caricamento dei dati';
    });

    localStorage.setItem(this.id, JSON.stringify(this.settings));
  }

  format(record, field) {
    let value = null;
    let column = this.dataset.find(x => x.field === field);

    if (!column && !['date_created', 'date_modified'].includes(field)) return record[field];

    if (field.indexOf('.') > 0) {
      let parts = field.split('.');
      value = record[parts[0]] && record[parts[0]][parts[1]] ? record[parts[0]][parts[1]] : null;
    } else {
      value = record[field];
    }

    if (!value) return null;

    if (field === 'date_created' || field === 'date_modified') {
      return moment.utc(value, 'YYYY-MM-DD').local().format('DD/MM/YYYY');
    } else if (column.control === 'list' && column.datasource) {
      if (typeof column.datasource === 'string' && (column.datasource.indexOf('{') === 0 || column.datasource.indexOf('[') === 0)) {
        column.datasource = JSON.parse(column.datasource);
      }
      let view = column.datasource.model.view || null;
      let keys = !view ? null : view.match(/\{[a-zA-Z0-9_\.]*?\}/g);
      let values = JSON.parse(value);
      let join = column.datasource.model.join || ', ';
      if (view && keys) {
        values.forEach((v, i) => {
          let nw = view;
          for (let key of keys) nw = nw.replace(key, v[key.replace(/\{|\}/g, '')] || '');
          values[i] = nw;
        });
      } else {
        values.forEach((v, i) => {
          values[i] = Object.values(v).join(' ');
        });
      }
      return values.join(join);
    } else if (column.datamultiple && column.datasource) {
      let values = [];
      for (let v of value) {
        let keys = column.datatext.match(/\{[a-zA-Z0-9_\.]*?\}/g);
        if (keys) {
          let datatext = column.datatext;
          for (let key of keys) {
            datatext = datatext.replace(key, v[key.replace(/\{|\}/g, '')] || '');
          }
          values.push(datatext);
        } else values.push(v[column.datatext || 'text']);
      }
      return values.join(', ');
    } else if (!column.datamultiple && column.datasource && column.control !== 'file') {
      let keys = column.datatext.match(/\{[a-zA-Z0-9_\.]*?\}/g);
      if (typeof column.datasource === 'string' && (column.datasource.indexOf('{') === 0 || column.datasource.indexOf('[') === 0)) {
        column.datasource = JSON.parse(column.datasource);
      }
      if (keys) {
        let datatext = column.datatext;
        for (let key of keys) {
          datatext = datatext.replace(key, value[key.replace(/\{|\}/g, '')] || '');
        }
        return datatext;
      } else if (typeof value === 'string' && Array.isArray(column.datasource)) {
        let v = column.datasource.filter(x => {
          return String(x[column.datavalue]) === String(value);
        });
        if (v && v.length) return v[0][column.datatext];
        return value;
      }
      return value[column.datatext || 'text'];
    } else if (column.datatype === 'json') {
      return JSON.stringify(value);
    } else if (column.control === 'age') {
      return moment().diff(moment(value, 'YYYY-MM-DD'), 'years');
    } else if (column.datatype === 'date') {
      return (column.utc ? moment.utc(value, 'YYYY-MM-DD').local() : moment(value, 'YYYY-MM-DD')).format('DD/MM/YYYY');
    } else if (column.datatype === 'datetime') {
      return (column.utc ? moment.utc(value, 'YYYY-MM-DD HH:mm:ss').local() : moment(value, 'YYYY-MM-DD HH:mm:ss')).format('DD/MM/YYYY HH:mm:ss');
    }
    return value;
  }

  set_sort(field) {
    let sort = this.settings.sort_stack.indexOf(field) > -1 ? this.settings.sort[field] || null : null;
    if (sort) {
      sort.order = sort.order === 'asc' ? 'desc' : sort.order === 'desc' ? null : 'asc';
      if (!sort.order) {
        this.settings.sort[field] = {};
        this.settings.sort_stack.splice(this.settings.sort_stack.indexOf(field), 1);
      }
    } else {
      this.settings.sort_stack.push(field);
      this.settings.sort[field] = { order: 'asc' };
    }
    for (let f of this.settings.sort_stack) {
      this.settings.sort[f].class = 'sort-' + this.settings.sort[f].order + ' sort-' + (this.settings.sort_stack.indexOf(f) + 1);
    }
    this.load();
  }

  set_page(page) {
    let pages = Math.ceil(this.total / parseInt(this.settings.limit));
    if (page == 'first') this.settings.offset = 0;else if (page == 'prev') this.settings.offset = this.settings.offset - parseInt(this.settings.limit) > 0 ? this.settings.offset - parseInt(this.settings.limit) : 0;else if (page == 'next') this.settings.offset = !this.records.length ? this.settings.offset : this.settings.offset + parseInt(this.settings.limit) < this.total ? this.settings.offset + parseInt(this.settings.limit) : parseInt(this.settings.limit) * (pages - 1);else if (page == 'last') this.settings.offset = !this.records.length ? this.settings.offset : parseInt(this.settings.limit) * (pages - 1);else if (typeof page == 'number' || /^[0-9]*?$/g.test(page)) this.settings.offset = parseInt(this.settings.limit) * (parseInt(page) - 1);else return;
    this.load();
  }

  set_limit(limit) {
    this.settings.limit = limit;
    this.load();
  }

  show_options($event) {
    if (this.optionsOpen) return this.hide_options();

    let backdrop = document.createElement('div');
    backdrop.classList.add('ka-table-backdrop');
    backdrop.setAttribute('id', 'ka-table-backdrop-' + this.id);
    backdrop.addEventListener('click', event => {
      if (event.target == backdrop) this.hide_options();
    });
    document.getElementsByTagName('body')[0].insertBefore(backdrop, document.getElementsByTagName('body')[0].children[0]);

    let drawer = document.querySelectorAll('#' + this.id + ' .ka-table-options')[0];
    if ($event && $event.target) {
      let bounds = $event.target.getBoundingClientRect();
      drawer.style.top = bounds.top + 'px';
      drawer.style.left = bounds.left + bounds.width / 2 + 'px';
    }
    backdrop.appendChild(drawer);
    drawer.classList.remove('hidden');
    setTimeout(() => {
      drawer.classList.add('open');
      this.optionsOpen = true;
    }, 100);
  }
  hide_options() {
    if (!this.optionsOpen) return;

    let drawer = document.querySelectorAll('#ka-table-backdrop-' + this.id + ' .ka-table-options')[0];
    drawer.classList.remove('open');
    setTimeout(() => {
      drawer.classList.add('hidden');
      this.element.appendChild(drawer);

      document.getElementsByTagName('body')[0].removeChild(document.getElementById('ka-table-backdrop-' + this.id));

      this.optionsOpen = false;
    }, 500);
  }

  show_filters() {
    if (this.filtersOpen) return this.hide_filters();

    let backdrop = document.createElement('div');
    backdrop.classList.add('ka-table-backdrop');
    backdrop.setAttribute('id', 'ka-table-backdrop-' + this.id);
    backdrop.addEventListener('click', event => {
      if (event.target == backdrop) this.hide_filters();
    });
    document.getElementsByTagName('body')[0].insertBefore(backdrop, document.getElementsByTagName('body')[0].children[0]);

    let drawer = document.querySelectorAll('#' + this.id + ' .ka-table-drawer.filters')[0];
    backdrop.appendChild(drawer);
    drawer.classList.remove('hidden');
    setTimeout(() => {
      drawer.classList.add('open');
      this.filtersOpen = true;
    }, 100);
  }
  hide_filters() {
    let drawer = document.querySelectorAll('#ka-table-backdrop-' + this.id + ' .ka-table-drawer.filters')[0];
    if (!drawer) return;
    drawer.classList.remove('open');
    setTimeout(() => {
      drawer.classList.add('hidden');
      this.element.appendChild(drawer);

      document.getElementsByTagName('body')[0].removeChild(document.getElementById('ka-table-backdrop-' + this.id));

      this.filtersOpen = false;
    }, 500);
  }
  apply_filters() {
    this.hide_filters();
    this.settings.offset = 0;
    this.load();
  }
  reset_filters() {
    if (this.filtersOpen) this.hide_filters();
    this.settings.offset = 0;
    for (let field of this.filters) {
      if (this.settings.filters[field.field]) {
        let default_operator = null;
        if (field.datamultiple) default_operator = '~~';else if (field.control === 'number') default_operator = '=';else if (field.control === 'age') default_operator = '=';
        this.settings.filters[field.field] = { operator: default_operator, value: null, value_from: null, value_to: null, control: field.control };
      }
      if (field.control === 'age') {
        field.control = 'number';
        field.datatype = 'tinyint(3)';
      }
    }
    this.load();
  }

  show_export() {
    if (this.exportOpen) return this.hide_export();

    let backdrop = document.createElement('div');
    backdrop.classList.add('ka-table-backdrop');
    backdrop.setAttribute('id', 'ka-table-backdrop-' + this.id);
    backdrop.addEventListener('click', event => {
      if (event.target == backdrop) this.hide_export();
    });
    document.getElementsByTagName('body')[0].insertBefore(backdrop, document.getElementsByTagName('body')[0].children[0]);

    let drawer = document.querySelectorAll('#' + this.id + ' .ka-table-drawer.export')[0];
    backdrop.appendChild(drawer);
    drawer.classList.remove('hidden');
    setTimeout(() => {
      drawer.classList.add('open');
      this.exportOpen = true;
    }, 100);
  }
  hide_export() {
    let drawer = document.querySelectorAll('#ka-table-backdrop-' + this.id + ' .ka-table-drawer.export')[0];
    drawer.classList.remove('open');
    setTimeout(() => {
      drawer.classList.add('hidden');
      this.element.appendChild(drawer);

      document.getElementsByTagName('body')[0].removeChild(document.getElementById('ka-table-backdrop-' + this.id));

      this.exportOpen = false;
    }, 500);
  }
  select_export() {
    for (let field of this.export_schema) {
      this.settings.exports[field.field] = true;
    }
  }
  unselect_export() {
    for (let field of this.export_schema) {
      this.settings.exports[field.field] = false;
    }
  }
  apply_export($event, exportPages = null) {
    if ($event && $event.model) $event.model.busy = true;
    let fields = Object.keys(this.settings.exports).reduce((acc, k) => {
      if (this.settings.exports[k] === true) acc.push(k);return acc;
    }, []).join(',');
    let query = this.export_query;
    if (exportPages === 'ALL') {
      query = query.replace(/&limit=\d*/, '');
      query = query.replace(/&offset=\d*/, '');
    }
    this.client.get(query + '&depth=1&meta=0&fields=' + fields).then(x => {
      let records = this.parse_response(x);
      if (!records.length) {
        this.toast.show('<strong>Nessun risulta alcun dato da esportare!</strong>', 'error');
        return;
      }
      let csv = [Object.keys(records[0]).join(';')];
      for (let record of records) {
        let values = [];
        for (let k of Object.keys(record)) {
          let value = this.dataset.find(f => {
            return f.field === k;
          }) ? this.format(record, k) : record[k];
          if (typeof value === 'string') {
            value = value.replace('"', '""');
            value = `"${value}"`;
          }
          values.push(value);
        }
        csv.push(values.join(';'));
      }
      csv = csv.join('\n');
      let blob = new Blob([csv], { type: 'text/csv' });
      let anchor = document.createElement('a');
      anchor.download = moment().format('YYYY-MM-DD_HH-mm') + '_' + this.endpoint.replace(/[^a-zA-Z0-9]/g, '-') + '.csv';
      anchor.href = window.URL.createObjectURL(blob);
      document.body.appendChild(anchor);
      anchor.click();
      document.body.removeChild(anchor);
      this.hide_export();
    }).finally(() => {
      if ($event && $event.model) $event.model.busy = false;
    });
  }

  add() {
    if (this.routes.edit === false) return;
    if (this.routes.dialog) {
      let childRoute = this.router.routes.filter(x => {
        return x.name == (this.routes.add || this.router.currentInstruction.config.name);
      })[0];
      this.dialog.open({
        title: childRoute.title,
        viewModel: childRoute.moduleId,
        viewModelParams: { id: 'new', data: this.routes.data || {} }
      }, true).whenClosed(response => {
        if (!response.wasCancelled) {
          this.load();
        }
      });
    } else this.router.navigateToRoute(this.routes.add || this.router.currentInstruction.config.name, { id: 'new' });
  }
  edit(record) {
    let listRefQuery = `${this.reference_query}&fields=id&limit=1&offset=${parseInt(this.settings.offset || 0, 10) + this.records.indexOf(record)}`;
    if (this.actions.indexOf('edit') < 0) return;
    if (this.routes.edit === false) return;
    if (this.routes.dialog) {
      let childRoute = this.router.routes.filter(x => {
        return x.name == (this.routes.edit || this.router.currentInstruction.config.name);
      })[0];
      this.dialog.open({
        title: childRoute.title,
        viewModel: childRoute.moduleId,
        viewModelParams: { id: record.id || record.uuid, listRefQuery: btoa(listRefQuery) }
      }, true).whenClosed(response => {
        if (!response.wasCancelled) {
          this.load();
        }
      });
    } else this.router.navigateToRoute(this.routes.edit || this.router.currentInstruction.config.name, { id: record.id || record.uuid, listRefQuery: btoa(listRefQuery) });
  }
  copy(record, deep = false) {
    if (this.routes.edit === false) return;
    if (deep) {
      let fields = this.dataset.filter(x => {
        return x.unique;
      });
      let duplicate = data => {
        let d = this.params && this.params.deepcopy ? JSON.parse(JSON.stringify(this.params.deepcopy)) : { depth: 1 };
        d.data = data;
        this.client.post(`duplicate/${record.id || record.uuid}`, d).then(x => {
          this.toast.show(`<strong>Record duplicato</strong>`, 'success');
          this.load();
        }).catch(x => {
          let error = JSON.parse(x.response).errors[0].msg;
          this.toast.show(`<strong>${error}</strong>`, 'error');
        });
      };
      if (fields.length) {
        let template = '',
            config = {},
            model = {};
        for (let field of fields) {
          config[field.field] = field;
          model[field.field] = null;
          template += `<ka-input config.bind="params.viewStrategyParams.config.${field.field}" value.bind="params.viewStrategyParams.model.${field.field}"></ka-input>`;
        }
        let viewStrategy = new InlineViewStrategy(`<template>${template}</template>`);
        let viewStrategyParams = { config: config, model: model };
        this.dialog.open({
          type: 'confirm',
          title: 'Duplica record',
          viewStrategy: viewStrategy,
          viewStrategyParams: viewStrategyParams
        }, true).whenClosed(response => {
          console.log(viewStrategyParams.model);
          if (!response.wasCancelled) {
            duplicate(viewStrategyParams.model);
          }
        });
      } else duplicate();
    } else {
      this.client.get(`${this.endpoint}/${record.id || record.uuid}`, { meta: 0, depth: 0 }).then(x => {
        let data = x.response;
        delete data.id;
        delete data.uuid;

        if (this.routes.dialog) {
          let childRoute = this.router.routes.filter(x => {
            return x.name == (this.routes.edit || this.router.currentInstruction.config.name);
          })[0];
          this.dialog.open({
            title: childRoute.title,
            viewModel: childRoute.moduleId,
            viewModelParams: { id: 'new', data: data }
          }, true).whenClosed(response => {
            if (!response.wasCancelled) {
              this.load();
            }
          });
        } else this.router.navigateToRoute(this.routes.edit || this.router.currentInstruction.config.name, { id: 'new', data: data });
      });
    }
  }
  delete(record) {
    if (this.routes.edit === false) return;
    this.dialog.open({
      type: 'confirm',
      class: 'warning',
      title: 'Elimina',
      body: 'Eliminare definitivamente il record?'
    }, true).whenClosed(response => {
      if (!response.wasCancelled) {
        this.client.delete(`${this.endpoint}/${record.id || record.uuid}`).then(x => {
          this.toast.show(`<strong>Record eliminato</strong>`, 'success');
          this.load();
        }).catch(x => {
          let error = JSON.parse(x.response).errors[0].msg;
          this.toast.show(`<strong>${error}</strong>`, 'error');
        });
      }
    });
  }
  parse_response(msg) {
    if (msg.responseType === 'json' && typeof msg.response === 'string') msg.response = JSON.parse(msg.response);
    return msg.response;
  }
}, (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'records', [_dec3], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'schema', [_dec4], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'export_schema', [_dec5], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, 'columns_schema', [_dec6], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, 'filters', [_dec7], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, 'endpoint', [_dec8], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, 'limit', [_dec9], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, 'depth', [_dec10], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, 'client', [_dec11], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, 'columns', [_dec12], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, 'filtrables', [_dec13], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, 'sortables', [_dec14], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, 'editables', [_dec15], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor14 = _applyDecoratedDescriptor(_class2.prototype, 'exportables', [_dec16], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor15 = _applyDecoratedDescriptor(_class2.prototype, 'prefilter', [_dec17], {
  enumerable: true,
  initializer: function () {
    return null;
  }
}), _descriptor16 = _applyDecoratedDescriptor(_class2.prototype, 'routes', [_dec18], {
  enumerable: true,
  initializer: function () {
    return { add: null, edit: null, dialog: false, data: {} };
  }
}), _descriptor17 = _applyDecoratedDescriptor(_class2.prototype, 'actions', [_dec19], {
  enumerable: true,
  initializer: function () {
    return ["filter", "export", "add", "edit"];
  }
}), _descriptor18 = _applyDecoratedDescriptor(_class2.prototype, 'params', [_dec20], {
  enumerable: true,
  initializer: function () {
    return {};
  }
}), _descriptor19 = _applyDecoratedDescriptor(_class2.prototype, 'query', [_dec21], {
  enumerable: true,
  initializer: function () {
    return '';
  }
})), _class2)) || _class) || _class);