'use strict';

System.register(['aurelia-framework'], function (_export, _context) {
  "use strict";

  var inject, customElement, bindable, _dec, _dec2, _dec3, _dec4, _class, _desc, _value, _class2, _descriptor, _descriptor2, KaButton;

  function _initDefineProp(target, property, descriptor, context) {
    if (!descriptor) return;
    Object.defineProperty(target, property, {
      enumerable: descriptor.enumerable,
      configurable: descriptor.configurable,
      writable: descriptor.writable,
      value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
    });
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
    var desc = {};
    Object['ke' + 'ys'](descriptor).forEach(function (key) {
      desc[key] = descriptor[key];
    });
    desc.enumerable = !!desc.enumerable;
    desc.configurable = !!desc.configurable;

    if ('value' in desc || desc.initializer) {
      desc.writable = true;
    }

    desc = decorators.slice().reverse().reduce(function (desc, decorator) {
      return decorator(target, property, desc) || desc;
    }, desc);

    if (context && desc.initializer !== void 0) {
      desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
      desc.initializer = undefined;
    }

    if (desc.initializer === void 0) {
      Object['define' + 'Property'](target, property, desc);
      desc = null;
    }

    return desc;
  }

  function _initializerWarningHelper(descriptor, context) {
    throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
  }

  return {
    setters: [function (_aureliaFramework) {
      inject = _aureliaFramework.inject;
      customElement = _aureliaFramework.customElement;
      bindable = _aureliaFramework.bindable;
    }],
    execute: function () {
      _export('KaButton', KaButton = (_dec = customElement('ka-button'), _dec2 = inject(Element), _dec3 = bindable(), _dec4 = bindable(), _dec(_class = _dec2(_class = (_class2 = function () {
        function KaButton(element) {
          _classCallCheck(this, KaButton);

          _initDefineProp(this, 'disabled', _descriptor, this);

          _initDefineProp(this, 'busy', _descriptor2, this);

          this._ready = false;

          this.element = element;
        }

        KaButton.prototype.bind = function bind(bindingContext) {
          this.parent = bindingContext;

          this.disabled = this.disabled === '' ? true : this.disabled;
          this.disabled = this.disabled === null || typeof this.disabled === 'undefined' ? false : this.disabled;
          this.disabled = this.disabled === 'false' ? false : Boolean(this.disabled);
        };

        KaButton.prototype.attached = function attached() {
          var _this = this;

          this._ready = true;
          this.element.addEventListener('click', function (e) {
            if (_this.disabled || _this.busy) e.stopPropagation();else e.model = _this;
          });

          var active = function active(e) {
            if (!_this.disabled && !_this.busy) _this.element.classList.toggle('active');
          };
          this.element.addEventListener('mousedown', active);
          this.element.addEventListener('touchstart', active);
          this.element.addEventListener('mouseup', active);
          this.element.addEventListener('touchend', active);

          this.init();
        };

        KaButton.prototype.disabledChanged = function disabledChanged(value) {
          value = value === 'false' ? false : Boolean(value);
          this.disabled = value;
          if (this._ready) this.init();
        };

        KaButton.prototype.busyChanged = function busyChanged(value) {
          if (this._ready) this.init();
        };

        KaButton.prototype.init = function init() {
          if (this.disabled === true) this.element.classList.add('disabled');else this.element.classList.remove('disabled');
          if (this.busy) this.element.classList.add('busy');else this.element.classList.remove('busy');
        };

        return KaButton;
      }(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'disabled', [_dec3], {
        enumerable: true,
        initializer: null
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'busy', [_dec4], {
        enumerable: true,
        initializer: function initializer() {
          return false;
        }
      })), _class2)) || _class) || _class));

      _export('KaButton', KaButton);
    }
  };
});