'use strict';

System.register(['environment'], function (_export, _context) {
  "use strict";

  var environment, KaConsole;

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  return {
    setters: [function (_environment) {
      environment = _environment.default;
    }],
    execute: function () {
      _export('KaConsole', KaConsole = function () {
        function KaConsole() {
          _classCallCheck(this, KaConsole);
        }

        KaConsole.prototype.log = function log() {
          this.debug(Object.values(arguments));
        };

        KaConsole.prototype.debug = function debug() {
          if (!environment.debug) return;
          console.debug.apply(console, ['%cK#DEBUG', 'background-color:#cbf7da;padding:5px;line-height:1;border-radius:3px;'].concat(Object.values(arguments)));
        };

        KaConsole.prototype.info = function info() {
          console.info.apply(console, ['%cK#INFO', 'background-color:#cbecf7;padding:5px;line-height:1;border-radius:3px;'].concat(Object.values(arguments)));
        };

        KaConsole.prototype.warn = function warn() {
          console.warn.apply(console, ['%cK#WARN', 'background-color:#f7e8cb;padding:5px;line-height:1;border-radius:3px;'].concat(Object.values(arguments)));
        };

        KaConsole.prototype.error = function error() {
          console.error.apply(console, ['%cK#ERROR', 'background-color:#f7cbcb;padding:5px;line-height:1;border-radius:3px;'].concat(Object.values(arguments)));
        };

        return KaConsole;
      }());

      _export('KaConsole', KaConsole);
    }
  };
});