'use strict';

System.register(['aurelia-framework', 'aurelia-dialog', './ka-dialog-vm'], function (_export, _context) {
  "use strict";

  var bindable, bindingMode, inject, DialogService, KaDialogVm, _dec, _class, KaDialog;

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  return {
    setters: [function (_aureliaFramework) {
      bindable = _aureliaFramework.bindable;
      bindingMode = _aureliaFramework.bindingMode;
      inject = _aureliaFramework.inject;
    }, function (_aureliaDialog) {
      DialogService = _aureliaDialog.DialogService;
    }, function (_kaDialogVm) {
      KaDialogVm = _kaDialogVm.KaDialogVm;
    }],
    execute: function () {
      _export('KaDialog', KaDialog = (_dec = inject(DialogService), _dec(_class = function () {
        function KaDialog(dialog) {
          _classCallCheck(this, KaDialog);

          this.dialog = dialog;
        }

        KaDialog.prototype.open = function open(model, lock) {
          return this.dialog.open({ viewModel: KaDialogVm, model: model, lock: lock || true });
        };

        return KaDialog;
      }()) || _class));

      _export('KaDialog', KaDialog);
    }
  };
});