'use strict';

System.register(['aurelia-framework'], function (_export, _context) {
  "use strict";

  var inject, customAttribute, _dec, _dec2, _class, KaEnterCustomAttribute;

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  return {
    setters: [function (_aureliaFramework) {
      inject = _aureliaFramework.inject;
      customAttribute = _aureliaFramework.customAttribute;
    }],
    execute: function () {
      _export('KaEnterCustomAttribute', KaEnterCustomAttribute = (_dec = customAttribute('ka-enter'), _dec2 = inject(Element), _dec(_class = _dec2(_class = function () {
        function KaEnterCustomAttribute(element) {
          var _this = this;

          _classCallCheck(this, KaEnterCustomAttribute);

          this._callback = null;

          this.element = element;

          this.element.addEventListener('keydown', function (e) {
            var inputs = [];
            if (_this.element.tagName === 'INPUT') inputs = [_this.element];else inputs = Array.from(_this.element.querySelectorAll('input'));
            if (e.keyCode === 13 && inputs.includes(e.target)) {
              if (typeof _this._callback === 'function') {
                e.target.blur();
                _this._callback({ event: e });
              }
            }
          });
        }

        KaEnterCustomAttribute.prototype.bind = function bind() {
          this._callback = this.value;
        };

        return KaEnterCustomAttribute;
      }()) || _class) || _class));

      _export('KaEnterCustomAttribute', KaEnterCustomAttribute);
    }
  };
});